/* Config.c generated by valac, the Vala compiler
 * generated from Config.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gconf/gconf-client.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
typedef struct _ConfigPrivate ConfigPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define COLLECTION_PAGE_TYPE_SORT_BY (collection_page_sort_by_get_type ())
typedef struct _ParamSpecConfig ParamSpecConfig;

struct _Config {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ConfigPrivate * priv;
};

struct _ConfigClass {
	GTypeClass parent_class;
	void (*finalize) (Config *self);
};

struct _ConfigPrivate {
	GConfClient* client;
};

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	COLLECTION_PAGE_SORT_BY_TITLE = 1,
	COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE = 2
} CollectionPageSortBy;

struct _ParamSpecConfig {
	GParamSpec parent_instance;
};


static Config* config_instance;
static Config* config_instance = NULL;
static gpointer config_parent_class = NULL;

gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void);
#define CONFIG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONFIG, ConfigPrivate))
enum  {
	CONFIG_DUMMY_PROPERTY
};
#define CONFIG_SLIDESHOW_DELAY_MAX 30.0
#define CONFIG_SLIDESHOW_DELAY_MIN 1.0
#define CONFIG_SLIDESHOW_DELAY_DEFAULT 5.0
#define CONFIG_WIDTH_DEFAULT 1024
#define CONFIG_HEIGHT_DEFAULT 768
#define CONFIG_SIDEBAR_MIN_POSITION 180
#define CONFIG_SIDEBAR_MAX_POSITION 1000
static Config* config_new (void);
static Config* config_construct (GType object_type);
Config* config_get_instance (void);
static void config_report_get_error (Config* self, const char* path, GError* err);
static void config_report_set_error (Config* self, const char* path, GError* err);
static gboolean config_get_bool (Config* self, const char* path, gboolean def);
static gboolean config_set_bool (Config* self, const char* path, gboolean value);
static gint config_get_int (Config* self, const char* path, gint def);
static gboolean config_set_int (Config* self, const char* path, gint value);
static double config_get_double (Config* self, const char* path, double def);
static gboolean config_set_double (Config* self, const char* path, double value);
static char* config_get_string (Config* self, const char* path, const char* def);
static gboolean config_set_string (Config* self, const char* path, const char* value);
gboolean config_set_flickr_auth_token (Config* self, const char* token);
gboolean config_clear_flickr_auth_token (Config* self);
char* config_get_flickr_auth_token (Config* self);
gboolean config_set_flickr_username (Config* self, const char* username);
gboolean config_clear_flickr_username (Config* self);
char* config_get_flickr_username (Config* self);
gboolean config_set_flickr_default_size (Config* self, gint sizecode);
gint config_get_flickr_default_size (Config* self);
gboolean config_set_flickr_visibility (Config* self, gint viscode);
gint config_get_flickr_visibility (Config* self);
gboolean config_set_default_service (Config* self, gint service_code);
gint config_get_default_service (Config* self);
gboolean config_set_facebook_session_key (Config* self, const char* key);
gboolean config_clear_facebook_session_key (Config* self);
char* config_get_facebook_session_key (Config* self);
gboolean config_set_facebook_session_secret (Config* self, const char* secret);
gboolean config_clear_facebook_session_secret (Config* self);
char* config_get_facebook_session_secret (Config* self);
gboolean config_set_facebook_uid (Config* self, const char* uid);
gboolean config_clear_facebook_uid (Config* self);
char* config_get_facebook_uid (Config* self);
gboolean config_set_facebook_user_name (Config* self, const char* user_name);
gboolean config_clear_facebook_user_name (Config* self);
char* config_get_facebook_user_name (Config* self);
gboolean config_set_display_basic_properties (Config* self, gboolean display);
gboolean config_get_display_basic_properties (Config* self);
gboolean config_set_display_extended_properties (Config* self, gboolean display);
gboolean config_get_display_extended_properties (Config* self);
gboolean config_set_display_photo_titles (Config* self, gboolean display);
gboolean config_get_display_photo_titles (Config* self);
gboolean config_set_slideshow_delay (Config* self, double delay);
double config_get_slideshow_delay (Config* self);
gboolean config_get_display_favorite_photos (Config* self);
gboolean config_set_display_favorite_photos (Config* self, gboolean display);
gboolean config_get_display_hidden_photos (Config* self);
gboolean config_set_display_hidden_photos (Config* self, gboolean display);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
gint config_get_sidebar_position (Config* self);
gboolean config_set_sidebar_position (Config* self, gint position);
gboolean config_get_events_sort_ascending (Config* self);
gboolean config_set_events_sort_ascending (Config* self, gboolean sort);
GType collection_page_sort_by_get_type (void);
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by);
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by);
static void config_finalize (Config* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 20 "Config.vala"
static Config* config_construct (GType object_type) {
#line 171 "Config.c"
	Config* self;
	GConfClient* _tmp0_;
	self = (Config*) g_type_create_instance (object_type);
#line 22 "Config.vala"
	g_assert (config_instance == NULL);
#line 24 "Config.vala"
	self->priv->client = (_tmp0_ = _g_object_ref0 (gconf_client_get_default ()), _g_object_unref0 (self->priv->client), _tmp0_);
#line 25 "Config.vala"
	g_assert (self->priv->client != NULL);
#line 181 "Config.c"
	return self;
}


#line 20 "Config.vala"
static Config* config_new (void) {
#line 20 "Config.vala"
	return config_construct (TYPE_CONFIG);
#line 190 "Config.c"
}


static gpointer _config_ref0 (gpointer self) {
	return self ? config_ref (self) : NULL;
}


#line 28 "Config.vala"
Config* config_get_instance (void) {
#line 201 "Config.c"
	Config* result;
#line 29 "Config.vala"
	if (config_instance == NULL) {
#line 205 "Config.c"
		Config* _tmp0_;
#line 30 "Config.vala"
		config_instance = (_tmp0_ = config_new (), _config_unref0 (config_instance), _tmp0_);
#line 209 "Config.c"
	}
	result = _config_ref0 (config_instance);
#line 32 "Config.vala"
	return result;
#line 214 "Config.c"
}


#line 35 "Config.vala"
static void config_report_get_error (Config* self, const char* path, GError* err) {
#line 35 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 35 "Config.vala"
	g_return_if_fail (path != NULL);
#line 36 "Config.vala"
	g_warning ("Config.vala:36: Unable to get GConf value at %s: %s", path, err->message);
#line 226 "Config.c"
}


#line 39 "Config.vala"
static void config_report_set_error (Config* self, const char* path, GError* err) {
#line 39 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 39 "Config.vala"
	g_return_if_fail (path != NULL);
#line 40 "Config.vala"
	g_warning ("Config.vala:40: Unable to set GConf value at %s: %s", path, err->message);
#line 238 "Config.c"
}


#line 43 "Config.vala"
static gboolean config_get_bool (Config* self, const char* path, gboolean def) {
#line 244 "Config.c"
	gboolean result;
	GError * _inner_error_;
#line 43 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 43 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 251 "Config.c"
	_inner_error_ = NULL;
	{
		gboolean _tmp0_;
#line 45 "Config.vala"
		_tmp0_ = gconf_client_get_bool (self->priv->client, path, &_inner_error_);
#line 257 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch71_g_error;
			goto __finally71;
		}
		result = _tmp0_;
#line 45 "Config.vala"
		return result;
#line 265 "Config.c"
	}
	goto __finally71;
	__catch71_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 47 "Config.vala"
			config_report_get_error (self, path, err);
#line 276 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 49 "Config.vala"
			return result;
#line 281 "Config.c"
		}
	}
	__finally71:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 53 "Config.vala"
static gboolean config_set_bool (Config* self, const char* path, gboolean value) {
#line 295 "Config.c"
	gboolean result;
	GError * _inner_error_;
#line 53 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 53 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 302 "Config.c"
	_inner_error_ = NULL;
	{
#line 55 "Config.vala"
		gconf_client_set_bool (self->priv->client, path, value, &_inner_error_);
#line 307 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch72_g_error;
			goto __finally72;
		}
		result = TRUE;
#line 57 "Config.vala"
		return result;
#line 315 "Config.c"
	}
	goto __finally72;
	__catch72_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 59 "Config.vala"
			config_report_set_error (self, path, err);
#line 326 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 61 "Config.vala"
			return result;
#line 331 "Config.c"
		}
	}
	__finally72:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 65 "Config.vala"
static gint config_get_int (Config* self, const char* path, gint def) {
#line 345 "Config.c"
	gint result;
	GError * _inner_error_;
#line 65 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 65 "Config.vala"
	g_return_val_if_fail (path != NULL, 0);
#line 352 "Config.c"
	_inner_error_ = NULL;
	{
		gint value;
		gint _tmp0_ = 0;
#line 67 "Config.vala"
		value = gconf_client_get_int (self->priv->client, path, &_inner_error_);
#line 359 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch73_g_error;
			goto __finally73;
		}
#line 69 "Config.vala"
		if (value != 0.0) {
#line 69 "Config.vala"
			_tmp0_ = value;
#line 368 "Config.c"
		} else {
#line 69 "Config.vala"
			_tmp0_ = def;
#line 372 "Config.c"
		}
		result = _tmp0_;
#line 69 "Config.vala"
		return result;
#line 377 "Config.c"
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 71 "Config.vala"
			config_report_get_error (self, path, err);
#line 388 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 73 "Config.vala"
			return result;
#line 393 "Config.c"
		}
	}
	__finally73:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


#line 77 "Config.vala"
static gboolean config_set_int (Config* self, const char* path, gint value) {
#line 407 "Config.c"
	gboolean result;
	GError * _inner_error_;
#line 77 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 77 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 414 "Config.c"
	_inner_error_ = NULL;
	{
#line 79 "Config.vala"
		gconf_client_set_int (self->priv->client, path, value, &_inner_error_);
#line 419 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch74_g_error;
			goto __finally74;
		}
		result = TRUE;
#line 81 "Config.vala"
		return result;
#line 427 "Config.c"
	}
	goto __finally74;
	__catch74_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 83 "Config.vala"
			config_report_set_error (self, path, err);
#line 438 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 85 "Config.vala"
			return result;
#line 443 "Config.c"
		}
	}
	__finally74:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 89 "Config.vala"
static double config_get_double (Config* self, const char* path, double def) {
#line 457 "Config.c"
	double result;
	GError * _inner_error_;
#line 89 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 89 "Config.vala"
	g_return_val_if_fail (path != NULL, 0.0);
#line 464 "Config.c"
	_inner_error_ = NULL;
	{
		double value;
		double _tmp0_ = 0.0;
#line 91 "Config.vala"
		value = gconf_client_get_float (self->priv->client, path, &_inner_error_);
#line 471 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
			goto __finally75;
		}
#line 93 "Config.vala"
		if (value != 0.0) {
#line 93 "Config.vala"
			_tmp0_ = value;
#line 480 "Config.c"
		} else {
#line 93 "Config.vala"
			_tmp0_ = def;
#line 484 "Config.c"
		}
		result = _tmp0_;
#line 93 "Config.vala"
		return result;
#line 489 "Config.c"
	}
	goto __finally75;
	__catch75_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 95 "Config.vala"
			config_report_get_error (self, path, err);
#line 500 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 97 "Config.vala"
			return result;
#line 505 "Config.c"
		}
	}
	__finally75:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
}


#line 101 "Config.vala"
static gboolean config_set_double (Config* self, const char* path, double value) {
#line 519 "Config.c"
	gboolean result;
	GError * _inner_error_;
#line 101 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 101 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 526 "Config.c"
	_inner_error_ = NULL;
	{
#line 103 "Config.vala"
		gconf_client_set_float (self->priv->client, path, value, &_inner_error_);
#line 531 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch76_g_error;
			goto __finally76;
		}
		result = TRUE;
#line 105 "Config.vala"
		return result;
#line 539 "Config.c"
	}
	goto __finally76;
	__catch76_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 107 "Config.vala"
			config_report_set_error (self, path, err);
#line 550 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 109 "Config.vala"
			return result;
#line 555 "Config.c"
		}
	}
	__finally76:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
#line 1037 "glib-2.0.vapi"
	return result;
#line 573 "Config.c"
}


#line 113 "Config.vala"
static char* config_get_string (Config* self, const char* path, const char* def) {
#line 579 "Config.c"
	char* result;
	GError * _inner_error_;
#line 113 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 113 "Config.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 586 "Config.c"
	_inner_error_ = NULL;
	{
		char* stored;
		const char* _tmp0_;
		gboolean _tmp1_ = FALSE;
#line 115 "Config.vala"
		stored = g_strdup (gconf_client_get_string (self->priv->client, path, &_inner_error_));
#line 594 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch77_g_error;
			goto __finally77;
		}
		_tmp0_ = NULL;
#line 117 "Config.vala"
		if (stored == NULL) {
#line 117 "Config.vala"
			_tmp1_ = TRUE;
#line 604 "Config.c"
		} else {
#line 117 "Config.vala"
			_tmp1_ = string_get_length (stored) == 0;
#line 608 "Config.c"
		}
#line 117 "Config.vala"
		if (_tmp1_) {
#line 117 "Config.vala"
			_tmp0_ = NULL;
#line 614 "Config.c"
		} else {
#line 117 "Config.vala"
			_tmp0_ = stored;
#line 618 "Config.c"
		}
		result = g_strdup (_tmp0_);
		_g_free0 (stored);
#line 117 "Config.vala"
		return result;
#line 624 "Config.c"
	}
	goto __finally77;
	__catch77_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 119 "Config.vala"
			config_report_get_error (self, path, err);
#line 635 "Config.c"
			result = g_strdup (def);
			_g_error_free0 (err);
#line 121 "Config.vala"
			return result;
#line 640 "Config.c"
		}
	}
	__finally77:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 125 "Config.vala"
static gboolean config_set_string (Config* self, const char* path, const char* value) {
#line 654 "Config.c"
	gboolean result;
	GError * _inner_error_;
#line 125 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 125 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 125 "Config.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 663 "Config.c"
	_inner_error_ = NULL;
	{
#line 127 "Config.vala"
		gconf_client_set_string (self->priv->client, path, value, &_inner_error_);
#line 668 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch78_g_error;
			goto __finally78;
		}
		result = TRUE;
#line 129 "Config.vala"
		return result;
#line 676 "Config.c"
	}
	goto __finally78;
	__catch78_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 131 "Config.vala"
			config_report_set_error (self, path, err);
#line 687 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 133 "Config.vala"
			return result;
#line 692 "Config.c"
		}
	}
	__finally78:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 137 "Config.vala"
gboolean config_clear_flickr_auth_token (Config* self) {
#line 706 "Config.c"
	gboolean result;
#line 137 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 710 "Config.c"
	result = config_set_flickr_auth_token (self, "");
#line 138 "Config.vala"
	return result;
#line 714 "Config.c"
}


#line 141 "Config.vala"
gboolean config_set_flickr_auth_token (Config* self, const char* token) {
#line 720 "Config.c"
	gboolean result;
#line 141 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 141 "Config.vala"
	g_return_val_if_fail (token != NULL, FALSE);
#line 726 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/auth_token", token);
#line 142 "Config.vala"
	return result;
#line 730 "Config.c"
}


#line 145 "Config.vala"
char* config_get_flickr_auth_token (Config* self) {
#line 736 "Config.c"
	char* result;
	char* stored_value;
	const char* _tmp0_;
#line 145 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 146 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/auth_token", NULL);
#line 744 "Config.c"
	_tmp0_ = NULL;
#line 147 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 147 "Config.vala"
		_tmp0_ = stored_value;
#line 750 "Config.c"
	} else {
#line 147 "Config.vala"
		_tmp0_ = NULL;
#line 754 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 147 "Config.vala"
	return result;
#line 760 "Config.c"
}


#line 150 "Config.vala"
gboolean config_clear_flickr_username (Config* self) {
#line 766 "Config.c"
	gboolean result;
#line 150 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 770 "Config.c"
	result = config_set_flickr_username (self, "");
#line 151 "Config.vala"
	return result;
#line 774 "Config.c"
}


#line 154 "Config.vala"
gboolean config_set_flickr_username (Config* self, const char* username) {
#line 780 "Config.c"
	gboolean result;
#line 154 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 154 "Config.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 786 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/username", username);
#line 155 "Config.vala"
	return result;
#line 790 "Config.c"
}


#line 158 "Config.vala"
char* config_get_flickr_username (Config* self) {
#line 796 "Config.c"
	char* result;
	char* stored_value;
	const char* _tmp0_;
#line 158 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 159 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/username", NULL);
#line 804 "Config.c"
	_tmp0_ = NULL;
#line 160 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 160 "Config.vala"
		_tmp0_ = stored_value;
#line 810 "Config.c"
	} else {
#line 160 "Config.vala"
		_tmp0_ = NULL;
#line 814 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 160 "Config.vala"
	return result;
#line 820 "Config.c"
}


#line 163 "Config.vala"
gboolean config_set_flickr_default_size (Config* self, gint sizecode) {
#line 826 "Config.c"
	gboolean result;
#line 163 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 830 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/default_size", sizecode + 1);
#line 164 "Config.vala"
	return result;
#line 834 "Config.c"
}


#line 167 "Config.vala"
gint config_get_flickr_default_size (Config* self) {
#line 840 "Config.c"
	gint result;
#line 167 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 844 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/default_size", 2) - 1;
#line 168 "Config.vala"
	return result;
#line 848 "Config.c"
}


#line 171 "Config.vala"
gboolean config_set_flickr_visibility (Config* self, gint viscode) {
#line 854 "Config.c"
	gboolean result;
#line 171 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 858 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/visibility", viscode + 1);
#line 172 "Config.vala"
	return result;
#line 862 "Config.c"
}


#line 175 "Config.vala"
gint config_get_flickr_visibility (Config* self) {
#line 868 "Config.c"
	gint result;
#line 175 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 872 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/visibility", 1) - 1;
#line 176 "Config.vala"
	return result;
#line 876 "Config.c"
}


#line 179 "Config.vala"
gboolean config_set_default_service (Config* self, gint service_code) {
#line 882 "Config.c"
	gboolean result;
#line 179 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 886 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/default_service", service_code + 1);
#line 180 "Config.vala"
	return result;
#line 890 "Config.c"
}


#line 183 "Config.vala"
gint config_get_default_service (Config* self) {
#line 896 "Config.c"
	gint result;
#line 183 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 900 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/default_service", 1) - 1;
#line 184 "Config.vala"
	return result;
#line 904 "Config.c"
}


#line 187 "Config.vala"
gboolean config_clear_facebook_session_key (Config* self) {
#line 910 "Config.c"
	gboolean result;
#line 187 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 914 "Config.c"
	result = config_set_facebook_session_key (self, "");
#line 188 "Config.vala"
	return result;
#line 918 "Config.c"
}


#line 191 "Config.vala"
gboolean config_set_facebook_session_key (Config* self, const char* key) {
#line 924 "Config.c"
	gboolean result;
#line 191 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 191 "Config.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 930 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_key", key);
#line 192 "Config.vala"
	return result;
#line 934 "Config.c"
}


#line 195 "Config.vala"
char* config_get_facebook_session_key (Config* self) {
#line 940 "Config.c"
	char* result;
#line 195 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 944 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_key", NULL);
#line 196 "Config.vala"
	return result;
#line 948 "Config.c"
}


#line 199 "Config.vala"
gboolean config_clear_facebook_session_secret (Config* self) {
#line 954 "Config.c"
	gboolean result;
#line 199 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 958 "Config.c"
	result = config_set_facebook_session_secret (self, "");
#line 200 "Config.vala"
	return result;
#line 962 "Config.c"
}


#line 203 "Config.vala"
gboolean config_set_facebook_session_secret (Config* self, const char* secret) {
#line 968 "Config.c"
	gboolean result;
#line 203 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 203 "Config.vala"
	g_return_val_if_fail (secret != NULL, FALSE);
#line 974 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_secret", secret);
#line 204 "Config.vala"
	return result;
#line 978 "Config.c"
}


#line 207 "Config.vala"
char* config_get_facebook_session_secret (Config* self) {
#line 984 "Config.c"
	char* result;
#line 207 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 988 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_secret", NULL);
#line 208 "Config.vala"
	return result;
#line 992 "Config.c"
}


#line 211 "Config.vala"
gboolean config_clear_facebook_uid (Config* self) {
#line 998 "Config.c"
	gboolean result;
#line 211 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1002 "Config.c"
	result = config_set_facebook_uid (self, "");
#line 212 "Config.vala"
	return result;
#line 1006 "Config.c"
}


#line 215 "Config.vala"
gboolean config_set_facebook_uid (Config* self, const char* uid) {
#line 1012 "Config.c"
	gboolean result;
#line 215 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 215 "Config.vala"
	g_return_val_if_fail (uid != NULL, FALSE);
#line 1018 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/uid", uid);
#line 216 "Config.vala"
	return result;
#line 1022 "Config.c"
}


#line 219 "Config.vala"
char* config_get_facebook_uid (Config* self) {
#line 1028 "Config.c"
	char* result;
#line 219 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1032 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/uid", NULL);
#line 220 "Config.vala"
	return result;
#line 1036 "Config.c"
}


#line 223 "Config.vala"
gboolean config_clear_facebook_user_name (Config* self) {
#line 1042 "Config.c"
	gboolean result;
#line 223 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1046 "Config.c"
	result = config_set_facebook_user_name (self, "");
#line 224 "Config.vala"
	return result;
#line 1050 "Config.c"
}


#line 227 "Config.vala"
gboolean config_set_facebook_user_name (Config* self, const char* user_name) {
#line 1056 "Config.c"
	gboolean result;
#line 227 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 227 "Config.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 1062 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/user_name", user_name);
#line 228 "Config.vala"
	return result;
#line 1066 "Config.c"
}


#line 231 "Config.vala"
char* config_get_facebook_user_name (Config* self) {
#line 1072 "Config.c"
	char* result;
#line 231 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1076 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/user_name", NULL);
#line 232 "Config.vala"
	return result;
#line 1080 "Config.c"
}


#line 235 "Config.vala"
gboolean config_set_display_basic_properties (Config* self, gboolean display) {
#line 1086 "Config.c"
	gboolean result;
#line 235 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1090 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", display);
#line 236 "Config.vala"
	return result;
#line 1094 "Config.c"
}


#line 239 "Config.vala"
gboolean config_get_display_basic_properties (Config* self) {
#line 1100 "Config.c"
	gboolean result;
#line 239 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1104 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", TRUE);
#line 240 "Config.vala"
	return result;
#line 1108 "Config.c"
}


#line 243 "Config.vala"
gboolean config_set_display_extended_properties (Config* self, gboolean display) {
#line 1114 "Config.c"
	gboolean result;
#line 243 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1118 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", display);
#line 244 "Config.vala"
	return result;
#line 1122 "Config.c"
}


#line 247 "Config.vala"
gboolean config_get_display_extended_properties (Config* self) {
#line 1128 "Config.c"
	gboolean result;
#line 247 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1132 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", FALSE);
#line 248 "Config.vala"
	return result;
#line 1136 "Config.c"
}


#line 251 "Config.vala"
gboolean config_set_display_photo_titles (Config* self, gboolean display) {
#line 1142 "Config.c"
	gboolean result;
#line 251 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1146 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", display);
#line 252 "Config.vala"
	return result;
#line 1150 "Config.c"
}


#line 255 "Config.vala"
gboolean config_get_display_photo_titles (Config* self) {
#line 1156 "Config.c"
	gboolean result;
#line 255 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1160 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", FALSE);
#line 256 "Config.vala"
	return result;
#line 1164 "Config.c"
}


#line 259 "Config.vala"
gboolean config_set_slideshow_delay (Config* self, double delay) {
#line 1170 "Config.c"
	gboolean result;
#line 259 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1174 "Config.c"
	result = config_set_double (self, "/apps/shotwell/preferences/slideshow/delay", delay);
#line 260 "Config.vala"
	return result;
#line 1178 "Config.c"
}


#line 263 "Config.vala"
double config_get_slideshow_delay (Config* self) {
#line 1184 "Config.c"
	double result;
#line 263 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1188 "Config.c"
	result = CLAMP (config_get_double (self, "/apps/shotwell/preferences/slideshow/delay", CONFIG_SLIDESHOW_DELAY_DEFAULT), CONFIG_SLIDESHOW_DELAY_MIN, CONFIG_SLIDESHOW_DELAY_MAX);
#line 264 "Config.vala"
	return result;
#line 1192 "Config.c"
}


#line 268 "Config.vala"
gboolean config_get_display_favorite_photos (Config* self) {
#line 1198 "Config.c"
	gboolean result;
#line 268 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1202 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_favorite_photos", FALSE);
#line 269 "Config.vala"
	return result;
#line 1206 "Config.c"
}


#line 272 "Config.vala"
gboolean config_set_display_favorite_photos (Config* self, gboolean display) {
#line 1212 "Config.c"
	gboolean result;
#line 272 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1216 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_favorite_photos", display);
#line 273 "Config.vala"
	return result;
#line 1220 "Config.c"
}


#line 276 "Config.vala"
gboolean config_get_display_hidden_photos (Config* self) {
#line 1226 "Config.c"
	gboolean result;
#line 276 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1230 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_hidden_photos", FALSE);
#line 277 "Config.vala"
	return result;
#line 1234 "Config.c"
}


#line 280 "Config.vala"
gboolean config_set_display_hidden_photos (Config* self, gboolean display) {
#line 1240 "Config.c"
	gboolean result;
#line 280 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1244 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_hidden_photos", display);
#line 281 "Config.vala"
	return result;
#line 1248 "Config.c"
}


#line 284 "Config.vala"
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1254 "Config.c"
	Dimensions _tmp0_ = {0};
#line 284 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 285 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/library_maximize", FALSE);
#line 286 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/library_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/library_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1262 "Config.c"
}


#line 291 "Config.vala"
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1268 "Config.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 291 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 292 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/library_maximize", maximize)) {
#line 293 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/library_width", (*dimensions).width);
#line 1278 "Config.c"
	} else {
#line 292 "Config.vala"
		_tmp1_ = FALSE;
#line 1282 "Config.c"
	}
#line 292 "Config.vala"
	if (_tmp1_) {
#line 294 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/library_height", (*dimensions).height);
#line 1288 "Config.c"
	} else {
#line 292 "Config.vala"
		_tmp0_ = FALSE;
#line 1292 "Config.c"
	}
	result = _tmp0_;
#line 292 "Config.vala"
	return result;
#line 1297 "Config.c"
}


#line 297 "Config.vala"
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1303 "Config.c"
	Dimensions _tmp0_ = {0};
#line 297 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 298 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/direct_maximize", FALSE);
#line 299 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/direct_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/direct_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1311 "Config.c"
}


#line 304 "Config.vala"
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1317 "Config.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 304 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 305 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/direct_maximize", maximize)) {
#line 306 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_width", (*dimensions).width);
#line 1327 "Config.c"
	} else {
#line 305 "Config.vala"
		_tmp1_ = FALSE;
#line 1331 "Config.c"
	}
#line 305 "Config.vala"
	if (_tmp1_) {
#line 307 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_height", (*dimensions).height);
#line 1337 "Config.c"
	} else {
#line 305 "Config.vala"
		_tmp0_ = FALSE;
#line 1341 "Config.c"
	}
	result = _tmp0_;
#line 305 "Config.vala"
	return result;
#line 1346 "Config.c"
}


#line 310 "Config.vala"
gint config_get_sidebar_position (Config* self) {
#line 1352 "Config.c"
	gint result;
#line 310 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1356 "Config.c"
	result = CLAMP (config_get_int (self, "/apps/shotwell/preferences/window/pane_position", CONFIG_SIDEBAR_MIN_POSITION), CONFIG_SIDEBAR_MIN_POSITION, CONFIG_SIDEBAR_MAX_POSITION);
#line 311 "Config.vala"
	return result;
#line 1360 "Config.c"
}


#line 314 "Config.vala"
gboolean config_set_sidebar_position (Config* self, gint position) {
#line 1366 "Config.c"
	gboolean result;
#line 314 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1370 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/window/pane_position", position);
#line 315 "Config.vala"
	return result;
#line 1374 "Config.c"
}


#line 318 "Config.vala"
gboolean config_get_events_sort_ascending (Config* self) {
#line 1380 "Config.c"
	gboolean result;
#line 318 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1384 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", FALSE);
#line 319 "Config.vala"
	return result;
#line 1388 "Config.c"
}


#line 322 "Config.vala"
gboolean config_set_events_sort_ascending (Config* self, gboolean sort) {
#line 1394 "Config.c"
	gboolean result;
#line 322 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1398 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", sort);
#line 323 "Config.vala"
	return result;
#line 1402 "Config.c"
}


#line 326 "Config.vala"
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 326 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 327 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", FALSE);
#line 328 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", (gint) COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE);
#line 1414 "Config.c"
}


#line 331 "Config.vala"
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 1420 "Config.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 331 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 332 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", sort_order)) {
#line 333 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", sort_by);
#line 1429 "Config.c"
	} else {
#line 332 "Config.vala"
		_tmp0_ = FALSE;
#line 1433 "Config.c"
	}
	result = _tmp0_;
#line 332 "Config.vala"
	return result;
#line 1438 "Config.c"
}


#line 336 "Config.vala"
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 336 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 337 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", TRUE);
#line 338 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", (gint) COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE);
#line 1450 "Config.c"
}


#line 341 "Config.vala"
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 1456 "Config.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 341 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 342 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", sort_order)) {
#line 343 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", sort_by);
#line 1465 "Config.c"
	} else {
#line 342 "Config.vala"
		_tmp0_ = FALSE;
#line 1469 "Config.c"
	}
	result = _tmp0_;
#line 342 "Config.vala"
	return result;
#line 1474 "Config.c"
}


static void value_config_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_config_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		config_unref (value->data[0].v_pointer);
	}
}


static void value_config_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = config_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_config_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_config_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Config* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = config_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_config_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Config** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = config_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecConfig* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CONFIG), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_config (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG), NULL);
	return value->data[0].v_pointer;
}


void value_set_config (GValue* value, gpointer v_object) {
	Config* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIG));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		config_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		config_unref (old);
	}
}


static void config_class_init (ConfigClass * klass) {
	config_parent_class = g_type_class_peek_parent (klass);
	CONFIG_CLASS (klass)->finalize = config_finalize;
	g_type_class_add_private (klass, sizeof (ConfigPrivate));
}


static void config_instance_init (Config * self) {
	self->priv = CONFIG_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void config_finalize (Config* obj) {
	Config * self;
	self = CONFIG (obj);
	_g_object_unref0 (self->priv->client);
}


GType config_get_type (void) {
	static GType config_type_id = 0;
	if (config_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { value_config_init, value_config_free_value, value_config_copy_value, value_config_peek_pointer, "p", value_config_collect_value, "p", value_config_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ConfigClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) config_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Config), 0, (GInstanceInitFunc) config_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		config_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Config", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return config_type_id;
}


gpointer config_ref (gpointer instance) {
	Config* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void config_unref (gpointer instance) {
	Config* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CONFIG_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




