/* Debug.c generated by valac, the Vala compiler
 * generated from Debug.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>



extern gboolean debug_info_enabled;
gboolean debug_info_enabled = FALSE;
extern gboolean debug_debug_enabled;
gboolean debug_debug_enabled = FALSE;
extern gboolean debug_message_enabled;
gboolean debug_message_enabled = FALSE;
extern gboolean debug_warning_enabled;
gboolean debug_warning_enabled = FALSE;
extern gboolean debug_critical_enabled;
gboolean debug_critical_enabled = FALSE;

void debug_info_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_info_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_debug_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_debug_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_message_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_message_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_warning_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_warning_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_critical_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_critical_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_init (void);
void debug_terminate (void);
void debug_log (FILE* stream, const char* prefix, const char* message);



#line 46 "Debug.vala"
static void _debug_info_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 48 "Debug.c"
	debug_info_handler (log_domain, log_levels, message);
}


#line 51 "Debug.vala"
static void _debug_debug_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 55 "Debug.c"
	debug_debug_handler (log_domain, log_levels, message);
}


#line 56 "Debug.vala"
static void _debug_message_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 62 "Debug.c"
	debug_message_handler (log_domain, log_levels, message);
}


#line 61 "Debug.vala"
static void _debug_warning_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 69 "Debug.c"
	debug_warning_handler (log_domain, log_levels, message);
}


#line 66 "Debug.vala"
static void _debug_critical_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 76 "Debug.c"
	debug_critical_handler (log_domain, log_levels, message);
}


#line 14 "Debug.vala"
void debug_init (void) {
#line 15 "Debug.vala"
	if (g_getenv ("SHOTWELL_LOG") != NULL) {
#line 16 "Debug.vala"
		debug_info_enabled = TRUE;
#line 17 "Debug.vala"
		debug_debug_enabled = TRUE;
#line 18 "Debug.vala"
		debug_message_enabled = TRUE;
#line 19 "Debug.vala"
		debug_warning_enabled = TRUE;
#line 20 "Debug.vala"
		debug_critical_enabled = TRUE;
#line 95 "Debug.c"
	} else {
#line 22 "Debug.vala"
		debug_info_enabled = g_getenv ("SHOTWELL_INFO") != NULL;
#line 23 "Debug.vala"
		debug_debug_enabled = g_getenv ("SHOTWELL_DEBUG") != NULL;
#line 24 "Debug.vala"
		debug_message_enabled = g_getenv ("SHOTWELL_MESSAGE") != NULL;
#line 25 "Debug.vala"
		debug_warning_enabled = g_getenv ("SHOTWELL_WARNING") != NULL;
#line 26 "Debug.vala"
		debug_critical_enabled = g_getenv ("SHOTWELL_CRITICAL") != NULL;
#line 107 "Debug.c"
	}
#line 29 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_INFO, _debug_info_handler_glog_func, NULL);
#line 30 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_DEBUG, _debug_debug_handler_glog_func, NULL);
#line 31 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_MESSAGE, _debug_message_handler_glog_func, NULL);
#line 32 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_WARNING, _debug_warning_handler_glog_func, NULL);
#line 33 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_CRITICAL, _debug_critical_handler_glog_func, NULL);
#line 119 "Debug.c"
}


#line 36 "Debug.vala"
void debug_terminate (void) {
#line 125 "Debug.c"
}


#line 39 "Debug.vala"
void debug_log (FILE* stream, const char* prefix, const char* message) {
#line 39 "Debug.vala"
	g_return_if_fail (stream != NULL);
#line 39 "Debug.vala"
	g_return_if_fail (prefix != NULL);
#line 39 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 40 "Debug.vala"
	fputs (prefix, stream);
#line 41 "Debug.vala"
	fputs (message, stream);
#line 42 "Debug.vala"
	fputc ('\n', stream);
#line 43 "Debug.vala"
	fflush (stream);
#line 145 "Debug.c"
}


#line 46 "Debug.vala"
void debug_info_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 46 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 47 "Debug.vala"
	if (debug_info_enabled) {
#line 48 "Debug.vala"
		debug_log (stdout, "[INF] ", message);
#line 157 "Debug.c"
	}
}


#line 51 "Debug.vala"
void debug_debug_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 51 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 52 "Debug.vala"
	if (debug_debug_enabled) {
#line 53 "Debug.vala"
		debug_log (stdout, "[DBG] ", message);
#line 170 "Debug.c"
	}
}


#line 56 "Debug.vala"
void debug_message_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 56 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 57 "Debug.vala"
	if (debug_message_enabled) {
#line 58 "Debug.vala"
		debug_log (stderr, "[MSG] ", message);
#line 183 "Debug.c"
	}
}


#line 61 "Debug.vala"
void debug_warning_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 61 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 62 "Debug.vala"
	if (debug_warning_enabled) {
#line 63 "Debug.vala"
		debug_log (stderr, "[WRN] ", message);
#line 196 "Debug.c"
	}
}


#line 66 "Debug.vala"
void debug_critical_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 66 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 67 "Debug.vala"
	if (debug_critical_enabled) {
#line 68 "Debug.vala"
		debug_log (stderr, "[CRT] ", message);
#line 209 "Debug.c"
	}
}




