/* Dimensions.c generated by valac, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};



GType scale_constraint_get_type (void);
char* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result);
char* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio);
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result);
GType scaling_get_type (void);
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result);
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result);
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
char* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self, Scaling* scaling);



#line 14 "Dimensions.vala"
char* scale_constraint_to_string (ScaleConstraint self) {
#line 109 "Dimensions.c"
	char* result;
#line 15 "Dimensions.vala"
	switch (self) {
#line 113 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			result = g_strdup (_ ("Original size"));
#line 17 "Dimensions.vala"
			return result;
#line 119 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			result = g_strdup (_ ("Width or height"));
#line 20 "Dimensions.vala"
			return result;
#line 126 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			result = g_strdup (_ ("Width"));
#line 23 "Dimensions.vala"
			return result;
#line 133 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			result = g_strdup (_ ("Height"));
#line 26 "Dimensions.vala"
			return result;
#line 140 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = g_strdup ("Fill Viewport");
#line 30 "Dimensions.vala"
			return result;
#line 147 "Dimensions.c"
		}
	}
#line 33 "Dimensions.vala"
	g_warn_if_reached ();
#line 152 "Dimensions.c"
	result = NULL;
#line 35 "Dimensions.vala"
	return result;
#line 156 "Dimensions.c"
}



GType scale_constraint_get_type (void) {
	static GType scale_constraint_type_id = 0;
	if (G_UNLIKELY (scale_constraint_type_id == 0)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
	}
	return scale_constraint_type_id;
}


#line 43 "Dimensions.vala"
void dimensions_init (Dimensions *self, gint width, gint height) {
#line 173 "Dimensions.c"
	memset (self, 0, sizeof (Dimensions));
#line 44 "Dimensions.vala"
	g_assert ((width >= 0) && (height >= 0));
#line 46 "Dimensions.vala"
	(*self).width = width;
#line 47 "Dimensions.vala"
	(*self).height = height;
#line 181 "Dimensions.c"
}


#line 50 "Dimensions.vala"
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result) {
#line 187 "Dimensions.c"
	Dimensions _tmp0_ = {0};
#line 50 "Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 191 "Dimensions.c"
	*result = (dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf)), _tmp0_);
#line 51 "Dimensions.vala"
	return;
#line 195 "Dimensions.c"
}


#line 54 "Dimensions.vala"
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result) {
#line 201 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, (*allocation).width, (*allocation).height), _tmp0_);
#line 55 "Dimensions.vala"
	return;
#line 206 "Dimensions.c"
}


#line 58 "Dimensions.vala"
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result) {
#line 212 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, (*rect).width, (*rect).height), _tmp0_);
#line 59 "Dimensions.vala"
	return;
#line 217 "Dimensions.c"
}


#line 62 "Dimensions.vala"
gboolean dimensions_has_area (Dimensions *self) {
#line 223 "Dimensions.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 63 "Dimensions.vala"
	if ((*self).width > 0) {
#line 63 "Dimensions.vala"
		_tmp0_ = (*self).height > 0;
#line 230 "Dimensions.c"
	} else {
#line 63 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 234 "Dimensions.c"
	}
	result = _tmp0_;
#line 63 "Dimensions.vala"
	return result;
#line 239 "Dimensions.c"
}


#line 66 "Dimensions.vala"
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result) {
#line 245 "Dimensions.c"
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
#line 67 "Dimensions.vala"
	if ((*self).width > (*min).width) {
#line 67 "Dimensions.vala"
		_tmp0_ = (*self).width;
#line 253 "Dimensions.c"
	} else {
#line 67 "Dimensions.vala"
		_tmp0_ = (*min).width;
#line 257 "Dimensions.c"
	}
#line 68 "Dimensions.vala"
	if ((*self).height > (*min).height) {
#line 68 "Dimensions.vala"
		_tmp1_ = (*self).height;
#line 263 "Dimensions.c"
	} else {
#line 68 "Dimensions.vala"
		_tmp1_ = (*min).height;
#line 267 "Dimensions.c"
	}
	*result = (dimensions_init (&_tmp2_, _tmp0_, _tmp1_), _tmp2_);
#line 67 "Dimensions.vala"
	return;
#line 272 "Dimensions.c"
}


#line 71 "Dimensions.vala"
char* dimensions_to_string (Dimensions *self) {
#line 278 "Dimensions.c"
	char* result;
	result = g_strdup_printf ("%dx%d", (*self).width, (*self).height);
#line 72 "Dimensions.vala"
	return result;
#line 283 "Dimensions.c"
}


#line 75 "Dimensions.vala"
gboolean dimensions_equals (Dimensions *self, Dimensions* dim) {
#line 289 "Dimensions.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 76 "Dimensions.vala"
	if ((*self).width == (*dim).width) {
#line 76 "Dimensions.vala"
		_tmp0_ = (*self).height == (*dim).height;
#line 296 "Dimensions.c"
	} else {
#line 76 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 300 "Dimensions.c"
	}
	result = _tmp0_;
#line 76 "Dimensions.vala"
	return result;
#line 305 "Dimensions.c"
}


#line 80 "Dimensions.vala"
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge) {
#line 311 "Dimensions.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 81 "Dimensions.vala"
	if (abs ((*self).width - (*dim).width) <= fudge) {
#line 81 "Dimensions.vala"
		_tmp0_ = abs ((*self).height - (*dim).height) <= fudge;
#line 318 "Dimensions.c"
	} else {
#line 81 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 322 "Dimensions.c"
	}
	result = _tmp0_;
#line 81 "Dimensions.vala"
	return result;
#line 327 "Dimensions.c"
}


#line 84 "Dimensions.vala"
gint dimensions_major_axis (Dimensions *self) {
#line 333 "Dimensions.c"
	gint result;
	result = MAX ((*self).width, (*self).height);
#line 85 "Dimensions.vala"
	return result;
#line 338 "Dimensions.c"
}


#line 88 "Dimensions.vala"
gint dimensions_minor_axis (Dimensions *self) {
#line 344 "Dimensions.c"
	gint result;
	result = MIN ((*self).width, (*self).height);
#line 89 "Dimensions.vala"
	return result;
#line 349 "Dimensions.c"
}


#line 92 "Dimensions.vala"
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result) {
#line 355 "Dimensions.c"
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 93 "Dimensions.vala"
	g_assert (scale > 0);
#line 96 "Dimensions.vala"
	if ((*self).width == scale) {
#line 96 "Dimensions.vala"
		_tmp0_ = TRUE;
#line 364 "Dimensions.c"
	} else {
#line 96 "Dimensions.vala"
		_tmp0_ = (*self).height == scale;
#line 368 "Dimensions.c"
	}
#line 96 "Dimensions.vala"
	if (_tmp0_) {
#line 372 "Dimensions.c"
		Dimensions _tmp1_ = {0};
		*result = (dimensions_init (&_tmp1_, (*self).width, (*self).height), _tmp1_);
#line 97 "Dimensions.vala"
		return;
#line 377 "Dimensions.c"
	}
#line 100 "Dimensions.vala"
	if (!scale_up) {
#line 381 "Dimensions.c"
		gboolean _tmp3_ = FALSE;
#line 100 "Dimensions.vala"
		if ((*self).width < scale) {
#line 100 "Dimensions.vala"
			_tmp3_ = (*self).height < scale;
#line 387 "Dimensions.c"
		} else {
#line 100 "Dimensions.vala"
			_tmp3_ = FALSE;
#line 391 "Dimensions.c"
		}
#line 100 "Dimensions.vala"
		_tmp2_ = _tmp3_;
#line 395 "Dimensions.c"
	} else {
#line 100 "Dimensions.vala"
		_tmp2_ = FALSE;
#line 399 "Dimensions.c"
	}
#line 100 "Dimensions.vala"
	if (_tmp2_) {
#line 403 "Dimensions.c"
		Dimensions _tmp4_ = {0};
		*result = (dimensions_init (&_tmp4_, (*self).width, (*self).height), _tmp4_);
#line 101 "Dimensions.vala"
		return;
#line 408 "Dimensions.c"
	}
#line 103 "Dimensions.vala"
	if (((*self).width - scale) > ((*self).height - scale)) {
#line 412 "Dimensions.c"
		Dimensions _tmp5_ = {0};
		*result = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp5_), _tmp5_);
#line 104 "Dimensions.vala"
		return;
#line 417 "Dimensions.c"
	} else {
		Dimensions _tmp6_ = {0};
		*result = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp6_), _tmp6_);
#line 106 "Dimensions.vala"
		return;
#line 423 "Dimensions.c"
	}
}


#line 109 "Dimensions.vala"
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio) {
#line 110 "Dimensions.vala"
	*width_ratio = ((double) (*scaled).width) / ((double) (*self).width);
#line 111 "Dimensions.vala"
	*height_ratio = ((double) (*scaled).height) / ((double) (*self).height);
#line 434 "Dimensions.c"
}


#line 114 "Dimensions.vala"
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result) {
#line 440 "Dimensions.c"
	double width_ratio = 0.0;
	double height_ratio = 0.0;
	double scaled_width = 0.0;
	double scaled_height = 0.0;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions scaled;
#line 116 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), viewport, &width_ratio, &height_ratio);
#line 119 "Dimensions.vala"
	if (width_ratio < height_ratio) {
#line 120 "Dimensions.vala"
		scaled_width = (double) (*viewport).width;
#line 121 "Dimensions.vala"
		scaled_height = ((double) (*self).height) * width_ratio;
#line 459 "Dimensions.c"
	} else {
#line 123 "Dimensions.vala"
		scaled_width = ((double) (*self).width) * height_ratio;
#line 124 "Dimensions.vala"
		scaled_height = (double) (*viewport).height;
#line 465 "Dimensions.c"
	}
#line 127 "Dimensions.vala"
	scaled = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (scaled_width), (gint) round (scaled_height)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 129 "Dimensions.vala"
	g_assert (scaled.height <= (*viewport).height);
#line 130 "Dimensions.vala"
	g_assert (scaled.width <= (*viewport).width);
#line 473 "Dimensions.c"
	*result = scaled;
#line 132 "Dimensions.vala"
	return;
#line 477 "Dimensions.c"
}


#line 135 "Dimensions.vala"
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result) {
#line 483 "Dimensions.c"
	double width_ratio = 0.0;
	double height_ratio = 0.0;
	double scaled_width = 0.0;
	double scaled_height = 0.0;
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp5_;
	Dimensions _tmp4_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
#line 137 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), viewport, &width_ratio, &height_ratio);
#line 140 "Dimensions.vala"
	if ((*self).width < (*viewport).width) {
#line 140 "Dimensions.vala"
		_tmp0_ = (*self).height >= (*viewport).height;
#line 500 "Dimensions.c"
	} else {
#line 140 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 504 "Dimensions.c"
	}
#line 140 "Dimensions.vala"
	if (_tmp0_) {
#line 142 "Dimensions.vala"
		scaled_width = (double) (*viewport).width;
#line 143 "Dimensions.vala"
		scaled_height = ((double) (*self).height) * width_ratio;
#line 512 "Dimensions.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 144 "Dimensions.vala"
		if ((*self).width >= (*viewport).width) {
#line 144 "Dimensions.vala"
			_tmp1_ = (*self).height < (*viewport).height;
#line 519 "Dimensions.c"
		} else {
#line 144 "Dimensions.vala"
			_tmp1_ = FALSE;
#line 523 "Dimensions.c"
		}
#line 144 "Dimensions.vala"
		if (_tmp1_) {
#line 146 "Dimensions.vala"
			scaled_width = ((double) (*self).width) * height_ratio;
#line 147 "Dimensions.vala"
			scaled_height = (double) (*viewport).height;
#line 531 "Dimensions.c"
		} else {
			double ratio;
#line 150 "Dimensions.vala"
			ratio = MAX (width_ratio, height_ratio);
#line 152 "Dimensions.vala"
			scaled_width = ((double) (*self).width) * ratio;
#line 153 "Dimensions.vala"
			scaled_height = ((double) (*self).height) * ratio;
#line 540 "Dimensions.c"
		}
	}
	*result = (dimensions_floor ((_tmp4_ = (dimensions_init (&_tmp2_, (gint) round (scaled_width), (gint) round (scaled_height)), _tmp2_), &_tmp4_), (_tmp5_ = (dimensions_init (&_tmp3_, 1, 1), _tmp3_), &_tmp5_), &_tmp6_), _tmp6_);
#line 156 "Dimensions.vala"
	return;
#line 546 "Dimensions.c"
}


#line 159 "Dimensions.vala"
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result) {
#line 552 "Dimensions.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	GdkRectangle _tmp0_ = {0};
	GdkRectangle scaled_rect;
#line 161 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), scaled, &x_scale, &y_scale);
#line 163 "Dimensions.vala"
	scaled_rect = (memset (&_tmp0_, 0, sizeof (GdkRectangle)), _tmp0_);
#line 164 "Dimensions.vala"
	scaled_rect.x = (gint) round (((double) (*rect).x) * x_scale);
#line 165 "Dimensions.vala"
	scaled_rect.y = (gint) round (((double) (*rect).y) * y_scale);
#line 166 "Dimensions.vala"
	scaled_rect.width = (gint) round (((double) (*rect).width) * x_scale);
#line 167 "Dimensions.vala"
	scaled_rect.height = (gint) round (((double) (*rect).height) * y_scale);
#line 169 "Dimensions.vala"
	if (scaled_rect.width <= 0) {
#line 170 "Dimensions.vala"
		scaled_rect.width = 1;
#line 573 "Dimensions.c"
	}
#line 172 "Dimensions.vala"
	if (scaled_rect.height <= 0) {
#line 173 "Dimensions.vala"
		scaled_rect.height = 1;
#line 579 "Dimensions.c"
	}
	*result = scaled_rect;
#line 175 "Dimensions.vala"
	return;
#line 584 "Dimensions.c"
}


#line 179 "Dimensions.vala"
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result) {
#line 590 "Dimensions.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	double scale;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 181 "Dimensions.vala"
	dimensions_get_scale_ratios (original, scaled, &x_scale, &y_scale);
#line 183 "Dimensions.vala"
	scale = MIN (x_scale, y_scale);
#line 603 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (((double) (*self).width) * scale), (gint) round (((double) (*self).height) * scale)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 185 "Dimensions.vala"
	return;
#line 607 "Dimensions.c"
}


#line 189 "Dimensions.vala"
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result) {
#line 613 "Dimensions.c"
	double ratio;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 190 "Dimensions.vala"
	g_assert (scale > 0);
#line 192 "Dimensions.vala"
	ratio = ((double) scale) / ((double) (*self).width);
#line 624 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, scale, (gint) round (((double) (*self).height) * ratio)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 194 "Dimensions.vala"
	return;
#line 628 "Dimensions.c"
}


#line 197 "Dimensions.vala"
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result) {
#line 634 "Dimensions.c"
	double ratio;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 198 "Dimensions.vala"
	g_assert (scale > 0);
#line 200 "Dimensions.vala"
	ratio = ((double) scale) / ((double) (*self).height);
#line 645 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (((double) (*self).width) * ratio), scale), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 202 "Dimensions.vala"
	return;
#line 649 "Dimensions.c"
}


#line 205 "Dimensions.vala"
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result) {
#line 655 "Dimensions.c"
	Dimensions _tmp6_ = {0};
#line 206 "Dimensions.vala"
	switch (constraint) {
#line 659 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			Dimensions _tmp0_ = {0};
			*result = (dimensions_init (&_tmp0_, (*self).width, (*self).height), _tmp0_);
#line 208 "Dimensions.vala"
			return;
#line 666 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			Dimensions _tmp1_ = {0};
#line 211 "Dimensions.vala"
			if ((*self).width >= (*self).height) {
#line 673 "Dimensions.c"
				Dimensions _tmp2_ = {0};
#line 211 "Dimensions.vala"
				_tmp1_ = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp2_), _tmp2_);
#line 677 "Dimensions.c"
			} else {
				Dimensions _tmp3_ = {0};
#line 211 "Dimensions.vala"
				_tmp1_ = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp3_), _tmp3_);
#line 682 "Dimensions.c"
			}
			*result = _tmp1_;
#line 211 "Dimensions.vala"
			return;
#line 687 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			Dimensions _tmp4_ = {0};
			*result = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp4_), _tmp4_);
#line 214 "Dimensions.vala"
			return;
#line 695 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			Dimensions _tmp5_ = {0};
			*result = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp5_), _tmp5_);
#line 217 "Dimensions.vala"
			return;
#line 703 "Dimensions.c"
		}
	}
#line 220 "Dimensions.vala"
	g_error ("Dimensions.vala:220: Bad constraint: %d", (gint) constraint);
#line 708 "Dimensions.c"
	*result = (dimensions_init (&_tmp6_, 0, 0), _tmp6_);
#line 222 "Dimensions.vala"
	return;
#line 712 "Dimensions.c"
}


Dimensions* dimensions_dup (const Dimensions* self) {
	Dimensions* dup;
	dup = g_new0 (Dimensions, 1);
	memcpy (dup, self, sizeof (Dimensions));
	return dup;
}


void dimensions_free (Dimensions* self) {
	g_free (self);
}


GType dimensions_get_type (void) {
	static GType dimensions_type_id = 0;
	if (dimensions_type_id == 0) {
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
	}
	return dimensions_type_id;
}


#line 234 "Dimensions.vala"
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up) {
#line 740 "Dimensions.c"
	memset (self, 0, sizeof (Scaling));
#line 235 "Dimensions.vala"
	(*self).constraint = constraint;
#line 236 "Dimensions.vala"
	(*self).scale = scale;
#line 237 "Dimensions.vala"
	(*self).viewport = *viewport;
#line 238 "Dimensions.vala"
	(*self).scale_up = scale_up;
#line 750 "Dimensions.c"
}


#line 241 "Dimensions.vala"
void scaling_for_original (Scaling* result) {
#line 756 "Dimensions.c"
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), FALSE), _tmp1_);
#line 242 "Dimensions.vala"
	return;
#line 763 "Dimensions.c"
}


#line 245 "Dimensions.vala"
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result) {
#line 769 "Dimensions.c"
	Scaling _tmp2_ = {0};
	Dimensions _tmp1_;
	Dimensions _tmp0_ = {0};
#line 245 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 775 "Dimensions.c"
	*result = (scaling_for_viewport ((_tmp1_ = (scaling_get_screen_dimensions (window, &_tmp0_), _tmp0_), &_tmp1_), scale_up, &_tmp2_), _tmp2_);
#line 246 "Dimensions.vala"
	return;
#line 779 "Dimensions.c"
}


#line 249 "Dimensions.vala"
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result) {
#line 785 "Dimensions.c"
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 250 "Dimensions.vala"
	g_assert (pixels > 0);
#line 791 "Dimensions.c"
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), scale_up), _tmp1_);
#line 252 "Dimensions.vala"
	return;
#line 795 "Dimensions.c"
}


#line 255 "Dimensions.vala"
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result) {
#line 801 "Dimensions.c"
	Scaling _tmp0_ = {0};
#line 256 "Dimensions.vala"
	g_assert (dimensions_has_area (viewport));
#line 805 "Dimensions.c"
	*result = (scaling_init (&_tmp0_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, viewport, scale_up), _tmp0_);
#line 258 "Dimensions.vala"
	return;
#line 809 "Dimensions.c"
}


#line 261 "Dimensions.vala"
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result) {
#line 815 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Dimensions viewport;
	Scaling _tmp1_ = {0};
#line 261 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WIDGET (widget));
#line 262 "Dimensions.vala"
	viewport = (dimensions_for_allocation (&widget->allocation, &_tmp0_), _tmp0_);
#line 263 "Dimensions.vala"
	g_assert (dimensions_has_area (&viewport));
#line 825 "Dimensions.c"
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &viewport, scale_up), _tmp1_);
#line 265 "Dimensions.vala"
	return;
#line 829 "Dimensions.c"
}


#line 268 "Dimensions.vala"
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result) {
#line 835 "Dimensions.c"
	Scaling _tmp0_ = {0};
#line 269 "Dimensions.vala"
	g_assert (dimensions_has_area (viewport));
#line 839 "Dimensions.c"
	*result = (scaling_init (&_tmp0_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, viewport, TRUE), _tmp0_);
#line 271 "Dimensions.vala"
	return;
#line 843 "Dimensions.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 274 "Dimensions.vala"
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result) {
#line 854 "Dimensions.c"
	GdkScreen* screen;
	Dimensions _tmp0_ = {0};
#line 274 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 275 "Dimensions.vala"
	screen = _g_object_ref0 (gtk_window_get_screen (window));
#line 861 "Dimensions.c"
	*result = (dimensions_init (&_tmp0_, gdk_screen_get_width (screen), gdk_screen_get_height (screen)), _tmp0_);
	_g_object_unref0 (screen);
#line 277 "Dimensions.vala"
	return;
#line 866 "Dimensions.c"
	_g_object_unref0 (screen);
}


#line 280 "Dimensions.vala"
static gint scaling_scale_to_pixels (Scaling *self) {
#line 873 "Dimensions.c"
	gint result;
	gint _tmp0_ = 0;
#line 281 "Dimensions.vala"
	if ((*self).scale >= 0) {
#line 281 "Dimensions.vala"
		_tmp0_ = (*self).scale;
#line 880 "Dimensions.c"
	} else {
#line 281 "Dimensions.vala"
		_tmp0_ = 0;
#line 884 "Dimensions.c"
	}
	result = _tmp0_;
#line 281 "Dimensions.vala"
	return result;
#line 889 "Dimensions.c"
}


#line 284 "Dimensions.vala"
gboolean scaling_is_unscaled (Scaling *self) {
#line 895 "Dimensions.c"
	gboolean result;
	result = (*self).constraint == SCALE_CONSTRAINT_ORIGINAL;
#line 285 "Dimensions.vala"
	return result;
#line 900 "Dimensions.c"
}


#line 288 "Dimensions.vala"
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels) {
#line 906 "Dimensions.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 289 "Dimensions.vala"
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 289 "Dimensions.vala"
		_tmp0_ = TRUE;
#line 913 "Dimensions.c"
	} else {
#line 289 "Dimensions.vala"
		_tmp0_ = (*self).scale == SCALING_NO_SCALE;
#line 917 "Dimensions.c"
	}
#line 289 "Dimensions.vala"
	if (_tmp0_) {
#line 921 "Dimensions.c"
		result = FALSE;
#line 290 "Dimensions.vala"
		return result;
#line 925 "Dimensions.c"
	}
#line 292 "Dimensions.vala"
	*pixels = scaling_scale_to_pixels (&(*self));
#line 293 "Dimensions.vala"
	g_assert ((*pixels) > 0);
#line 931 "Dimensions.c"
	result = TRUE;
#line 295 "Dimensions.vala"
	return result;
#line 935 "Dimensions.c"
}


#line 298 "Dimensions.vala"
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 941 "Dimensions.c"
	gboolean result;
	gint pixels = 0;
	Dimensions _tmp0_ = {0};
#line 300 "Dimensions.vala"
	if (!scaling_is_best_fit (&(*self), original, &pixels)) {
#line 947 "Dimensions.c"
		result = FALSE;
#line 301 "Dimensions.vala"
		return result;
#line 951 "Dimensions.c"
	}
#line 303 "Dimensions.vala"
	*scaled = (dimensions_get_scaled (original, pixels, (*self).scale_up, &_tmp0_), _tmp0_);
#line 955 "Dimensions.c"
	result = TRUE;
#line 305 "Dimensions.vala"
	return result;
#line 959 "Dimensions.c"
}


#line 308 "Dimensions.vala"
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 965 "Dimensions.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 309 "Dimensions.vala"
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 309 "Dimensions.vala"
		_tmp0_ = TRUE;
#line 974 "Dimensions.c"
	} else {
#line 309 "Dimensions.vala"
		_tmp0_ = (*self).scale != SCALING_NO_SCALE;
#line 978 "Dimensions.c"
	}
#line 309 "Dimensions.vala"
	if (_tmp0_) {
#line 982 "Dimensions.c"
		result = FALSE;
#line 310 "Dimensions.vala"
		return result;
#line 986 "Dimensions.c"
	}
#line 312 "Dimensions.vala"
	g_assert (dimensions_has_area (&(*self).viewport));
#line 314 "Dimensions.vala"
	if (!(*self).scale_up) {
#line 314 "Dimensions.vala"
		_tmp2_ = (*original).width < (*self).viewport.width;
#line 994 "Dimensions.c"
	} else {
#line 314 "Dimensions.vala"
		_tmp2_ = FALSE;
#line 998 "Dimensions.c"
	}
#line 314 "Dimensions.vala"
	if (_tmp2_) {
#line 314 "Dimensions.vala"
		_tmp1_ = (*original).height < (*self).viewport.height;
#line 1004 "Dimensions.c"
	} else {
#line 314 "Dimensions.vala"
		_tmp1_ = FALSE;
#line 1008 "Dimensions.c"
	}
#line 314 "Dimensions.vala"
	if (_tmp1_) {
#line 315 "Dimensions.vala"
		*scaled = *original;
#line 1014 "Dimensions.c"
	} else {
		Dimensions _tmp3_ = {0};
#line 317 "Dimensions.vala"
		*scaled = (dimensions_get_scaled_proportional (original, &(*self).viewport, &_tmp3_), _tmp3_);
#line 1019 "Dimensions.c"
	}
	result = TRUE;
#line 319 "Dimensions.vala"
	return result;
#line 1024 "Dimensions.c"
}


#line 322 "Dimensions.vala"
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 1030 "Dimensions.c"
	gboolean result;
	Dimensions _tmp0_ = {0};
#line 323 "Dimensions.vala"
	if ((*self).constraint != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 1035 "Dimensions.c"
		result = FALSE;
#line 324 "Dimensions.vala"
		return result;
#line 1039 "Dimensions.c"
	}
#line 326 "Dimensions.vala"
	g_assert (dimensions_has_area (&(*self).viewport));
#line 327 "Dimensions.vala"
	*scaled = (dimensions_get_scaled_to_fill_viewport (original, &(*self).viewport, &_tmp0_), _tmp0_);
#line 1045 "Dimensions.c"
	result = TRUE;
#line 329 "Dimensions.vala"
	return result;
#line 1049 "Dimensions.c"
}


#line 332 "Dimensions.vala"
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result) {
#line 1055 "Dimensions.c"
	Dimensions scaled = {0};
	gboolean is_viewport;
#line 333 "Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1060 "Dimensions.c"
		*result = *original;
#line 334 "Dimensions.vala"
		return;
#line 1064 "Dimensions.c"
	}
#line 337 "Dimensions.vala"
	if (scaling_is_fill_viewport (&(*self), original, &scaled)) {
#line 1068 "Dimensions.c"
		*result = scaled;
#line 338 "Dimensions.vala"
		return;
#line 1072 "Dimensions.c"
	}
#line 340 "Dimensions.vala"
	if (scaling_is_best_fit_dimensions (&(*self), original, &scaled)) {
#line 1076 "Dimensions.c"
		*result = scaled;
#line 341 "Dimensions.vala"
		return;
#line 1080 "Dimensions.c"
	}
#line 343 "Dimensions.vala"
	is_viewport = scaling_is_for_viewport (&(*self), original, &scaled);
#line 344 "Dimensions.vala"
	g_assert (is_viewport);
#line 1086 "Dimensions.c"
	*result = scaled;
#line 346 "Dimensions.vala"
	return;
#line 1090 "Dimensions.c"
}


#line 349 "Dimensions.vala"
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up) {
#line 1096 "Dimensions.c"
	GdkPixbuf* result;
	Dimensions _tmp0_ = {0};
	Dimensions pixbuf_dim;
	gint pixels = 0;
	Dimensions scaled = {0};
	gboolean is_viewport;
#line 349 "Dimensions.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 350 "Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1107 "Dimensions.c"
		result = _g_object_ref0 (pixbuf);
#line 351 "Dimensions.vala"
		return result;
#line 1111 "Dimensions.c"
	}
#line 353 "Dimensions.vala"
	pixbuf_dim = (dimensions_for_pixbuf (pixbuf, &_tmp0_), _tmp0_);
#line 356 "Dimensions.vala"
	if (scaling_is_best_fit (&(*self), &pixbuf_dim, &pixels)) {
#line 1117 "Dimensions.c"
		result = scale_pixbuf (pixbuf, pixels, interp, scale_up);
#line 357 "Dimensions.vala"
		return result;
#line 1121 "Dimensions.c"
	}
#line 360 "Dimensions.vala"
	if (scaling_is_fill_viewport (&(*self), &pixbuf_dim, &scaled)) {
#line 1125 "Dimensions.c"
		result = resize_pixbuf (pixbuf, &scaled, interp);
#line 361 "Dimensions.vala"
		return result;
#line 1129 "Dimensions.c"
	}
#line 363 "Dimensions.vala"
	is_viewport = scaling_is_for_viewport (&(*self), &pixbuf_dim, &scaled);
#line 364 "Dimensions.vala"
	g_assert (is_viewport);
#line 1135 "Dimensions.c"
	result = resize_pixbuf (pixbuf, &scaled, interp);
#line 366 "Dimensions.vala"
	return result;
#line 1139 "Dimensions.c"
}


#line 369 "Dimensions.vala"
char* scaling_to_string (Scaling *self) {
#line 1145 "Dimensions.c"
	char* result;
#line 370 "Dimensions.vala"
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 1149 "Dimensions.c"
		result = g_strdup ("scaling: UNSCALED");
#line 371 "Dimensions.vala"
		return result;
#line 1153 "Dimensions.c"
	} else {
#line 372 "Dimensions.vala"
		if ((*self).constraint == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 1157 "Dimensions.c"
			char* _tmp0_;
			char* _tmp1_;
			result = (_tmp1_ = g_strdup_printf ("scaling: fill viewport %s", _tmp0_ = dimensions_to_string (&(*self).viewport)), _g_free0 (_tmp0_), _tmp1_);
#line 373 "Dimensions.vala"
			return result;
#line 1163 "Dimensions.c"
		} else {
#line 374 "Dimensions.vala"
			if ((*self).scale != SCALING_NO_SCALE) {
#line 1167 "Dimensions.c"
				const char* _tmp2_;
				_tmp2_ = NULL;
#line 376 "Dimensions.vala"
				if ((*self).scale_up) {
#line 376 "Dimensions.vala"
					_tmp2_ = "scaled up";
#line 1174 "Dimensions.c"
				} else {
#line 376 "Dimensions.vala"
					_tmp2_ = "not scaled up";
#line 1178 "Dimensions.c"
				}
				result = g_strdup_printf ("scaling: best-fit (%d pixels %s)", scaling_scale_to_pixels (&(*self)), _tmp2_);
#line 375 "Dimensions.vala"
				return result;
#line 1183 "Dimensions.c"
			} else {
				const char* _tmp3_;
				char* _tmp4_;
				char* _tmp5_;
				_tmp3_ = NULL;
#line 379 "Dimensions.vala"
				if ((*self).scale_up) {
#line 379 "Dimensions.vala"
					_tmp3_ = "scaled up";
#line 1193 "Dimensions.c"
				} else {
#line 379 "Dimensions.vala"
					_tmp3_ = "not scaled up";
#line 1197 "Dimensions.c"
				}
				result = (_tmp5_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp4_ = dimensions_to_string (&(*self).viewport), _tmp3_), _g_free0 (_tmp4_), _tmp5_);
#line 378 "Dimensions.vala"
				return result;
#line 1202 "Dimensions.c"
			}
		}
	}
}


#line 382 "Dimensions.vala"
gboolean scaling_equals (Scaling *self, Scaling* scaling) {
#line 1211 "Dimensions.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 383 "Dimensions.vala"
	if ((*self).constraint == (*scaling).constraint) {
#line 383 "Dimensions.vala"
		_tmp1_ = (*self).scale == (*scaling).scale;
#line 1219 "Dimensions.c"
	} else {
#line 383 "Dimensions.vala"
		_tmp1_ = FALSE;
#line 1223 "Dimensions.c"
	}
#line 383 "Dimensions.vala"
	if (_tmp1_) {
#line 384 "Dimensions.vala"
		_tmp0_ = dimensions_equals (&(*self).viewport, &(*scaling).viewport);
#line 1229 "Dimensions.c"
	} else {
#line 383 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 1233 "Dimensions.c"
	}
	result = _tmp0_;
#line 383 "Dimensions.vala"
	return result;
#line 1238 "Dimensions.c"
}


Scaling* scaling_dup (const Scaling* self) {
	Scaling* dup;
	dup = g_new0 (Scaling, 1);
	memcpy (dup, self, sizeof (Scaling));
	return dup;
}


void scaling_free (Scaling* self) {
	g_free (self);
}


GType scaling_get_type (void) {
	static GType scaling_type_id = 0;
	if (scaling_type_id == 0) {
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
	}
	return scaling_type_id;
}




