/* Exif.c generated by valac, the Vala compiler
 * generated from Exif.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <libexif/exif-entry.h>
#include <libexif/exif-content.h>
#include <libexif/exif-tag.h>
#include <libexif/exif-format.h>
#include <libexif/exif-data.h>
#include <string.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <libexif/exif-ifd.h>
#include <float.h>
#include <math.h>
#include <libexif/exif-utils.h>
#include <libexif/exif-byte-order.h>
#include <gio/gio.h>
#include <errno.h>
#include <gobject/gvaluecollector.h>

#define _exif_entry_unref0(var) ((var == NULL) ? NULL : (var = (exif_entry_unref (var), NULL)))
#define _exif_content_unref0(var) ((var == NULL) ? NULL : (var = (exif_content_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_PHOTO_EXIF (photo_exif_get_type ())
#define PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_EXIF, PhotoExif))
#define PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_EXIF, PhotoExifClass))
#define IS_PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_EXIF))
#define IS_PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_EXIF))
#define PHOTO_EXIF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_EXIF, PhotoExifClass))

typedef struct _PhotoExif PhotoExif;
typedef struct _PhotoExifClass PhotoExifClass;
typedef struct _PhotoExifPrivate PhotoExifPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define JPEG_TYPE_MARKER (jpeg_marker_get_type ())
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _ParamSpecPhotoExif ParamSpecPhotoExif;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	EXIF_ERROR_FILE_FORMAT
} ExifError;
#define EXIF_ERROR exif_error_quark ()
struct _PhotoExif {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoExifPrivate * priv;
};

struct _PhotoExifClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoExif *self);
};

struct _PhotoExifPrivate {
	GFile* file;
	ExifData* exif;
	gboolean no_exif;
};

typedef enum  {
	JPEG_MARKER_SOI = 0xD8,
	JPEG_MARKER_EOI = 0xD9,
	JPEG_MARKER_APP0 = 0xE0,
	JPEG_MARKER_APP1 = 0xE1
} JpegMarker;

struct _ParamSpecPhotoExif {
	GParamSpec parent_instance;
};


static gpointer photo_exif_parent_class = NULL;

ExifEntry* exif_alloc_entry (ExifContent* parent, ExifTag tag, ExifFormat format);
ExifEntry* exif_find_first_entry (ExifData* data, ExifTag tag, ExifFormat format);
gint exif_remove_all_tags (ExifData* data, ExifTag tag);
gboolean exif_convert_datetime (const char* datetime, time_t* timestamp);
gboolean exif_get_timestamp (ExifData* exif, time_t* timestamp);
ExifEntry* exif_find_entry (ExifData* exif, ExifIfd ifd, ExifTag tag, ExifFormat format, gint size);
ExifEntry* exif_find_entry_multiformat (ExifData* exif, ExifIfd ifd, ExifTag tag, ExifFormat format1, ExifFormat format2);
double exif_rational_to_double (ExifRational rational);
GType orientation_get_type (void);
Orientation exif_get_orientation (ExifData* exif);
void exif_set_orientation (ExifData** exif, Orientation orientation);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
gboolean exif_get_dimensions (ExifData* exif, Dimensions* dim);
void exif_set_dimensions (ExifData** exif, Dimensions* dim);
char* exif_get_exposure (ExifData* exif);
char* exif_get_aperture (ExifData* exif);
char* exif_get_iso (ExifData* exif);
char* exif_get_camera_make (ExifData* exif);
char* exif_get_camera_model (ExifData* exif);
char* exif_get_flash (ExifData* exif);
char* exif_get_focal_length (ExifData* exif);
ExifRational* exif_get_gps_rationals (ExifEntry* entry, ExifByteOrder byte_order, int* result_length1);
ExifRational* exif_get_raw_gps_lat (ExifData* exif, int* result_length1);
ExifRational* exif_get_raw_gps_long (ExifData* exif, int* result_length1);
double exif_get_angle (ExifRational* rationals, int rationals_length1);
double exif_get_gps_lat (ExifData* exif);
double exif_get_gps_long (ExifData* exif);
char* exif_get_gps_lat_ref (ExifData* exif);
char* exif_get_gps_long_ref (ExifData* exif);
char* exif_get_artist (ExifData* exif);
char* exif_get_copyright (ExifData* exif);
char* exif_get_software (ExifData* exif);
GQuark exif_error_quark (void);
void free (void* ptr);
gpointer photo_exif_ref (gpointer instance);
void photo_exif_unref (gpointer instance);
GParamSpec* param_spec_photo_exif (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_exif (GValue* value, gpointer v_object);
gpointer value_get_photo_exif (const GValue* value);
GType photo_exif_get_type (void);
#define PHOTO_EXIF_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_EXIF, PhotoExifPrivate))
enum  {
	PHOTO_EXIF_DUMMY_PROPERTY
};
PhotoExif* photo_exif_new (GFile* file);
PhotoExif* photo_exif_construct (GType object_type, GFile* file);
guint8* photo_exif_get_raw_exif (PhotoExif* self, gsize* raw_length, int* result_length1, GError** error);
gboolean photo_exif_has_exif (PhotoExif* self);
static void photo_exif_update (PhotoExif* self);
GType jpeg_marker_get_type (void);
gint jpeg_read_marker (GFileInputStream* fins, JpegMarker* marker, GError** error);
#define JPEG_MARKER_PREFIX ((guint8) 0xFF)
char* md5_binary (guint8* buffer, gsize length);
char* photo_exif_get_md5 (PhotoExif* self);
ExifData* photo_exif_get_exif (PhotoExif* self);
char* photo_exif_get_thumbnail_md5 (PhotoExif* self);
void photo_exif_set_exif (PhotoExif* self, ExifData* exif);
Orientation photo_exif_get_orientation (PhotoExif* self);
void photo_exif_set_orientation (PhotoExif* self, Orientation orientation);
gboolean photo_exif_get_dimensions (PhotoExif* self, Dimensions* dim);
void photo_exif_set_dimensions (PhotoExif* self, Dimensions* dim);
char* photo_exif_get_datetime (PhotoExif* self);
gboolean photo_exif_get_timestamp (PhotoExif* self, time_t* timestamp);
gint photo_exif_remove_all_tags (PhotoExif* self, ExifTag tag);
gboolean photo_exif_remove_thumbnail (PhotoExif* self);
static GFileOutputStream* photo_exif_create_temp (GFile* original, GFile** temp, GError** error);
void jpeg_write_marker (GFileOutputStream* fouts, JpegMarker marker, gint length, GError** error);
void photo_exif_commit (PhotoExif* self, GError** error);
static void photo_exif_finalize (PhotoExif* obj);

static const guint8 EXIF_SIGNATURE[] = {(guint8) 0x45, (guint8) 0x78, (guint8) 0x69, (guint8) 0x66};


#line 12 "Exif.vala"
ExifEntry* exif_alloc_entry (ExifContent* parent, ExifTag tag, ExifFormat format) {
#line 188 "Exif.c"
	ExifEntry* result;
	ExifEntry* entry;
#line 12 "Exif.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 15 "Exif.vala"
	entry = exif_entry_new ();
#line 16 "Exif.vala"
	exif_content_add_entry (parent, entry);
#line 17 "Exif.vala"
	exif_entry_initialize (entry, tag);
#line 199 "Exif.c"
	result = entry;
#line 19 "Exif.vala"
	return result;
#line 203 "Exif.c"
}


#line 22 "Exif.vala"
ExifEntry* exif_find_first_entry (ExifData* data, ExifTag tag, ExifFormat format) {
#line 209 "Exif.c"
	ExifEntry* result;
#line 22 "Exif.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 213 "Exif.c"
	{
		gint ctr;
#line 23 "Exif.vala"
		ctr = 0;
#line 218 "Exif.c"
		{
			gboolean _tmp0_;
#line 23 "Exif.vala"
			_tmp0_ = TRUE;
#line 23 "Exif.vala"
			while (TRUE) {
#line 225 "Exif.c"
				ExifContent* _tmp1_;
				ExifContent* content;
				ExifEntry* _tmp2_;
				ExifEntry* entry;
				gboolean _tmp3_ = FALSE;
#line 23 "Exif.vala"
				if (!_tmp0_) {
#line 23 "Exif.vala"
					ctr++;
#line 235 "Exif.c"
				}
#line 23 "Exif.vala"
				_tmp0_ = FALSE;
#line 23 "Exif.vala"
				if (!(ctr < ((gint) EXIF_IFD_COUNT))) {
#line 23 "Exif.vala"
					break;
#line 243 "Exif.c"
				}
#line 24 "Exif.vala"
				content = (_tmp1_ = data->ifd[ctr], (_tmp1_ == NULL) ? NULL : exif_content_ref (_tmp1_), _tmp1_);
#line 25 "Exif.vala"
				if (content == NULL) {
#line 249 "Exif.c"
					_exif_content_unref0 (content);
#line 26 "Exif.vala"
					continue;
#line 253 "Exif.c"
				}
#line 28 "Exif.vala"
				entry = (_tmp2_ = exif_content_get_entry (content, tag), (_tmp2_ == NULL) ? NULL : exif_entry_ref (_tmp2_), _tmp2_);
#line 29 "Exif.vala"
				if (entry == NULL) {
#line 259 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 30 "Exif.vala"
					continue;
#line 264 "Exif.c"
				}
#line 32 "Exif.vala"
				if (entry->format != format) {
#line 268 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 33 "Exif.vala"
					continue;
#line 273 "Exif.c"
				}
#line 35 "Exif.vala"
				if (format != EXIF_FORMAT_ASCII) {
#line 35 "Exif.vala"
					_tmp3_ = format != EXIF_FORMAT_UNDEFINED;
#line 279 "Exif.c"
				} else {
#line 35 "Exif.vala"
					_tmp3_ = FALSE;
#line 283 "Exif.c"
				}
#line 35 "Exif.vala"
				if (_tmp3_) {
#line 36 "Exif.vala"
					if (entry->size != exif_format_get_size (format)) {
#line 289 "Exif.c"
						_exif_content_unref0 (content);
						_exif_entry_unref0 (entry);
#line 37 "Exif.vala"
						continue;
#line 294 "Exif.c"
					}
				}
				result = entry;
				_exif_content_unref0 (content);
#line 40 "Exif.vala"
				return result;
#line 301 "Exif.c"
			}
		}
	}
	result = NULL;
#line 43 "Exif.vala"
	return result;
#line 308 "Exif.c"
}


#line 46 "Exif.vala"
gint exif_remove_all_tags (ExifData* data, ExifTag tag) {
#line 314 "Exif.c"
	gint result;
	gint count;
#line 46 "Exif.vala"
	g_return_val_if_fail (data != NULL, 0);
#line 47 "Exif.vala"
	count = 0;
#line 321 "Exif.c"
	{
		gint ctr;
#line 48 "Exif.vala"
		ctr = 0;
#line 326 "Exif.c"
		{
			gboolean _tmp0_;
#line 48 "Exif.vala"
			_tmp0_ = TRUE;
#line 48 "Exif.vala"
			while (TRUE) {
#line 333 "Exif.c"
				ExifContent* _tmp1_;
				ExifContent* content;
				ExifEntry* _tmp2_;
				ExifEntry* entry;
#line 48 "Exif.vala"
				if (!_tmp0_) {
#line 48 "Exif.vala"
					ctr++;
#line 342 "Exif.c"
				}
#line 48 "Exif.vala"
				_tmp0_ = FALSE;
#line 48 "Exif.vala"
				if (!(ctr < ((gint) EXIF_IFD_COUNT))) {
#line 48 "Exif.vala"
					break;
#line 350 "Exif.c"
				}
#line 49 "Exif.vala"
				content = (_tmp1_ = data->ifd[ctr], (_tmp1_ == NULL) ? NULL : exif_content_ref (_tmp1_), _tmp1_);
#line 50 "Exif.vala"
				if (content == NULL) {
#line 356 "Exif.c"
					_exif_content_unref0 (content);
#line 51 "Exif.vala"
					continue;
#line 360 "Exif.c"
				}
#line 53 "Exif.vala"
				entry = (_tmp2_ = exif_content_get_entry (content, tag), (_tmp2_ == NULL) ? NULL : exif_entry_ref (_tmp2_), _tmp2_);
#line 54 "Exif.vala"
				if (entry == NULL) {
#line 366 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 55 "Exif.vala"
					continue;
#line 371 "Exif.c"
				}
#line 57 "Exif.vala"
				exif_content_remove_entry (content, entry);
#line 58 "Exif.vala"
				count++;
#line 377 "Exif.c"
				_exif_content_unref0 (content);
				_exif_entry_unref0 (entry);
			}
		}
	}
	result = count;
#line 61 "Exif.vala"
	return result;
#line 386 "Exif.c"
}


#line 64 "Exif.vala"
gboolean exif_convert_datetime (const char* datetime, time_t* timestamp) {
#line 392 "Exif.c"
	gboolean result;
	struct tm _tmp0_ = {0};
	struct tm tm;
	gint count;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 64 "Exif.vala"
	g_return_val_if_fail (datetime != NULL, FALSE);
#line 65 "Exif.vala"
	tm = (memset (&_tmp0_, 0, sizeof (struct tm)), _tmp0_);
#line 66 "Exif.vala"
	count = sscanf (datetime, "%d:%d:%d %d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec);
#line 68 "Exif.vala"
	if (count != 6) {
#line 410 "Exif.c"
		result = FALSE;
#line 69 "Exif.vala"
		return result;
#line 414 "Exif.c"
	}
#line 72 "Exif.vala"
	if (tm.tm_year <= 1900) {
#line 72 "Exif.vala"
		_tmp5_ = TRUE;
#line 420 "Exif.c"
	} else {
#line 72 "Exif.vala"
		_tmp5_ = tm.tm_mon <= 0;
#line 424 "Exif.c"
	}
#line 72 "Exif.vala"
	if (_tmp5_) {
#line 72 "Exif.vala"
		_tmp4_ = TRUE;
#line 430 "Exif.c"
	} else {
#line 72 "Exif.vala"
		_tmp4_ = tm.tm_mday < 0;
#line 434 "Exif.c"
	}
#line 72 "Exif.vala"
	if (_tmp4_) {
#line 72 "Exif.vala"
		_tmp3_ = TRUE;
#line 440 "Exif.c"
	} else {
#line 72 "Exif.vala"
		_tmp3_ = tm.tm_hour < 0;
#line 444 "Exif.c"
	}
#line 72 "Exif.vala"
	if (_tmp3_) {
#line 72 "Exif.vala"
		_tmp2_ = TRUE;
#line 450 "Exif.c"
	} else {
#line 72 "Exif.vala"
		_tmp2_ = tm.tm_min < 0;
#line 454 "Exif.c"
	}
#line 72 "Exif.vala"
	if (_tmp2_) {
#line 72 "Exif.vala"
		_tmp1_ = TRUE;
#line 460 "Exif.c"
	} else {
#line 72 "Exif.vala"
		_tmp1_ = tm.tm_sec < 0;
#line 464 "Exif.c"
	}
#line 72 "Exif.vala"
	if (_tmp1_) {
#line 468 "Exif.c"
		result = FALSE;
#line 73 "Exif.vala"
		return result;
#line 472 "Exif.c"
	}
#line 75 "Exif.vala"
	tm.tm_year = tm.tm_year - 1900;
#line 76 "Exif.vala"
	tm.tm_mon--;
#line 77 "Exif.vala"
	tm.tm_isdst = -1;
#line 79 "Exif.vala"
	*timestamp = mktime (&tm);
#line 482 "Exif.c"
	result = TRUE;
#line 81 "Exif.vala"
	return result;
#line 486 "Exif.c"
}


#line 84 "Exif.vala"
gboolean exif_get_timestamp (ExifData* exif, time_t* timestamp) {
#line 492 "Exif.c"
	gboolean result;
	ExifEntry* entry;
#line 84 "Exif.vala"
	g_return_val_if_fail (exif != NULL, FALSE);
#line 85 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_DATE_TIME_ORIGINAL, EXIF_FORMAT_ASCII);
#line 86 "Exif.vala"
	if (entry != NULL) {
#line 501 "Exif.c"
		gint _tmp0__length1;
		gchar* _tmp0_;
		char* _tmp1_;
		char* datetime;
#line 87 "Exif.vala"
		datetime = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
#line 88 "Exif.vala"
		if (datetime != NULL) {
#line 89 "Exif.vala"
			if (exif_convert_datetime (datetime, timestamp)) {
#line 512 "Exif.c"
				result = TRUE;
				_g_free0 (datetime);
				_exif_entry_unref0 (entry);
#line 90 "Exif.vala"
				return result;
#line 518 "Exif.c"
			}
		}
		_g_free0 (datetime);
	}
	result = FALSE;
	_exif_entry_unref0 (entry);
#line 94 "Exif.vala"
	return result;
#line 527 "Exif.c"
}


#line 97 "Exif.vala"
ExifEntry* exif_find_entry (ExifData* exif, ExifIfd ifd, ExifTag tag, ExifFormat format, gint size) {
#line 533 "Exif.c"
	ExifEntry* result;
	ExifContent* _tmp0_;
	ExifContent* content;
	ExifEntry* _tmp1_;
	ExifEntry* entry;
	gboolean _tmp2_ = FALSE;
#line 97 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 99 "Exif.vala"
	content = (_tmp0_ = exif->ifd[(gint) ifd], (_tmp0_ == NULL) ? NULL : exif_content_ref (_tmp0_), _tmp0_);
#line 100 "Exif.vala"
	if (content == NULL) {
#line 546 "Exif.c"
		result = NULL;
		_exif_content_unref0 (content);
#line 101 "Exif.vala"
		return result;
#line 551 "Exif.c"
	}
#line 103 "Exif.vala"
	entry = (_tmp1_ = exif_content_get_entry (content, tag), (_tmp1_ == NULL) ? NULL : exif_entry_ref (_tmp1_), _tmp1_);
#line 104 "Exif.vala"
	if (entry == NULL) {
#line 557 "Exif.c"
		result = NULL;
		_exif_content_unref0 (content);
		_exif_entry_unref0 (entry);
#line 105 "Exif.vala"
		return result;
#line 563 "Exif.c"
	}
#line 107 "Exif.vala"
	if (entry->format != format) {
#line 567 "Exif.c"
		result = NULL;
		_exif_content_unref0 (content);
		_exif_entry_unref0 (entry);
#line 108 "Exif.vala"
		return result;
#line 573 "Exif.c"
	}
#line 111 "Exif.vala"
	if (format != EXIF_FORMAT_ASCII) {
#line 111 "Exif.vala"
		_tmp2_ = format != EXIF_FORMAT_UNDEFINED;
#line 579 "Exif.c"
	} else {
#line 111 "Exif.vala"
		_tmp2_ = FALSE;
#line 583 "Exif.c"
	}
#line 111 "Exif.vala"
	if (_tmp2_) {
#line 112 "Exif.vala"
		if (entry->size != (exif_format_get_size (format) * size)) {
#line 589 "Exif.c"
			result = NULL;
			_exif_content_unref0 (content);
			_exif_entry_unref0 (entry);
#line 113 "Exif.vala"
			return result;
#line 595 "Exif.c"
		}
	}
	result = entry;
	_exif_content_unref0 (content);
#line 116 "Exif.vala"
	return result;
#line 602 "Exif.c"
}


#line 119 "Exif.vala"
ExifEntry* exif_find_entry_multiformat (ExifData* exif, ExifIfd ifd, ExifTag tag, ExifFormat format1, ExifFormat format2) {
#line 608 "Exif.c"
	ExifEntry* result;
	ExifContent* _tmp0_;
	ExifContent* content;
	ExifEntry* _tmp1_;
	ExifEntry* entry;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 119 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 121 "Exif.vala"
	content = (_tmp0_ = exif->ifd[(gint) ifd], (_tmp0_ == NULL) ? NULL : exif_content_ref (_tmp0_), _tmp0_);
#line 122 "Exif.vala"
	if (content == NULL) {
#line 622 "Exif.c"
		result = NULL;
		_exif_content_unref0 (content);
#line 123 "Exif.vala"
		return result;
#line 627 "Exif.c"
	}
#line 126 "Exif.vala"
	entry = (_tmp1_ = exif_content_get_entry (content, tag), (_tmp1_ == NULL) ? NULL : exif_entry_ref (_tmp1_), _tmp1_);
#line 127 "Exif.vala"
	if (entry == NULL) {
#line 633 "Exif.c"
		result = NULL;
		_exif_content_unref0 (content);
		_exif_entry_unref0 (entry);
#line 128 "Exif.vala"
		return result;
#line 639 "Exif.c"
	}
#line 130 "Exif.vala"
	if (entry->format != format1) {
#line 130 "Exif.vala"
		_tmp2_ = entry->format != format2;
#line 645 "Exif.c"
	} else {
#line 130 "Exif.vala"
		_tmp2_ = FALSE;
#line 649 "Exif.c"
	}
#line 130 "Exif.vala"
	if (_tmp2_) {
#line 653 "Exif.c"
		result = NULL;
		_exif_content_unref0 (content);
		_exif_entry_unref0 (entry);
#line 131 "Exif.vala"
		return result;
#line 659 "Exif.c"
	}
#line 134 "Exif.vala"
	if (entry->format != EXIF_FORMAT_ASCII) {
#line 134 "Exif.vala"
		_tmp3_ = entry->format != EXIF_FORMAT_UNDEFINED;
#line 665 "Exif.c"
	} else {
#line 134 "Exif.vala"
		_tmp3_ = FALSE;
#line 669 "Exif.c"
	}
#line 134 "Exif.vala"
	if (_tmp3_) {
#line 673 "Exif.c"
		gboolean _tmp4_ = FALSE;
#line 135 "Exif.vala"
		if (entry->size != exif_format_get_size (format1)) {
#line 135 "Exif.vala"
			_tmp4_ = entry->size != exif_format_get_size (format2);
#line 679 "Exif.c"
		} else {
#line 135 "Exif.vala"
			_tmp4_ = FALSE;
#line 683 "Exif.c"
		}
#line 135 "Exif.vala"
		if (_tmp4_) {
#line 687 "Exif.c"
			result = NULL;
			_exif_content_unref0 (content);
			_exif_entry_unref0 (entry);
#line 136 "Exif.vala"
			return result;
#line 693 "Exif.c"
		}
	}
	result = entry;
	_exif_content_unref0 (content);
#line 139 "Exif.vala"
	return result;
#line 700 "Exif.c"
}


#line 142 "Exif.vala"
double exif_rational_to_double (ExifRational rational) {
#line 706 "Exif.c"
	double result;
	result = ((double) rational.numerator) / ((double) rational.denominator);
#line 143 "Exif.vala"
	return result;
#line 711 "Exif.c"
}


#line 146 "Exif.vala"
Orientation exif_get_orientation (ExifData* exif) {
#line 717 "Exif.c"
	Orientation result;
	ExifEntry* entry;
	gint o;
	gboolean _tmp0_ = FALSE;
#line 146 "Exif.vala"
	g_return_val_if_fail (exif != NULL, 0);
#line 147 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_0, EXIF_TAG_ORIENTATION, EXIF_FORMAT_SHORT, 1);
#line 148 "Exif.vala"
	if (entry == NULL) {
#line 728 "Exif.c"
		result = ORIENTATION_TOP_LEFT;
		_exif_entry_unref0 (entry);
#line 149 "Exif.vala"
		return result;
#line 733 "Exif.c"
	}
#line 151 "Exif.vala"
	o = (gint) exif_get_short (entry->data, exif_data_get_byte_order (exif));
#line 152 "Exif.vala"
	if (o < ((gint) ORIENTATION_MIN)) {
#line 152 "Exif.vala"
		_tmp0_ = TRUE;
#line 741 "Exif.c"
	} else {
#line 152 "Exif.vala"
		_tmp0_ = o > ((gint) ORIENTATION_MAX);
#line 745 "Exif.c"
	}
#line 152 "Exif.vala"
	if (_tmp0_) {
#line 749 "Exif.c"
		result = ORIENTATION_TOP_LEFT;
		_exif_entry_unref0 (entry);
#line 153 "Exif.vala"
		return result;
#line 754 "Exif.c"
	}
	result = (Orientation) o;
	_exif_entry_unref0 (entry);
#line 155 "Exif.vala"
	return result;
#line 760 "Exif.c"
}


#line 158 "Exif.vala"
void exif_set_orientation (ExifData** exif, Orientation orientation) {
#line 766 "Exif.c"
	ExifEntry* entry;
#line 158 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 159 "Exif.vala"
	entry = exif_find_first_entry (*exif, EXIF_TAG_ORIENTATION, EXIF_FORMAT_SHORT);
#line 160 "Exif.vala"
	if (entry == NULL) {
#line 774 "Exif.c"
		ExifEntry* _tmp0_;
#line 162 "Exif.vala"
		entry = (_tmp0_ = exif_alloc_entry ((*exif)->ifd[0], EXIF_TAG_ORIENTATION, EXIF_FORMAT_SHORT), _exif_entry_unref0 (entry), _tmp0_);
#line 778 "Exif.c"
	}
#line 165 "Exif.vala"
	exif_set_short (entry->data, exif_data_get_byte_order (*exif), (guint16) orientation);
#line 782 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 168 "Exif.vala"
gboolean exif_get_dimensions (ExifData* exif, Dimensions* dim) {
#line 789 "Exif.c"
	gboolean result;
	ExifEntry* width;
	ExifEntry* height;
	gboolean _tmp0_ = FALSE;
#line 168 "Exif.vala"
	g_return_val_if_fail (exif != NULL, FALSE);
#line 169 "Exif.vala"
	width = exif_find_entry_multiformat (exif, EXIF_IFD_EXIF, EXIF_TAG_PIXEL_X_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 171 "Exif.vala"
	height = exif_find_entry_multiformat (exif, EXIF_IFD_EXIF, EXIF_TAG_PIXEL_Y_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 173 "Exif.vala"
	if (width == NULL) {
#line 173 "Exif.vala"
		_tmp0_ = TRUE;
#line 804 "Exif.c"
	} else {
#line 173 "Exif.vala"
		_tmp0_ = height == NULL;
#line 808 "Exif.c"
	}
#line 173 "Exif.vala"
	if (_tmp0_) {
#line 812 "Exif.c"
		result = FALSE;
		_exif_entry_unref0 (width);
		_exif_entry_unref0 (height);
#line 174 "Exif.vala"
		return result;
#line 818 "Exif.c"
	}
#line 176 "Exif.vala"
	if (width->format == EXIF_FORMAT_SHORT) {
#line 177 "Exif.vala"
		(*dim).width = (gint) exif_get_short (width->data, exif_data_get_byte_order (exif));
#line 824 "Exif.c"
	} else {
#line 179 "Exif.vala"
		g_assert (width->format == EXIF_FORMAT_LONG);
#line 181 "Exif.vala"
		(*dim).width = (gint) exif_get_long (width->data, exif_data_get_byte_order (exif));
#line 830 "Exif.c"
	}
#line 184 "Exif.vala"
	if (height->format == EXIF_FORMAT_SHORT) {
#line 185 "Exif.vala"
		(*dim).height = (gint) exif_get_short (height->data, exif_data_get_byte_order (exif));
#line 836 "Exif.c"
	} else {
#line 187 "Exif.vala"
		g_assert (height->format == EXIF_FORMAT_LONG);
#line 189 "Exif.vala"
		(*dim).height = (gint) exif_get_long (height->data, exif_data_get_byte_order (exif));
#line 842 "Exif.c"
	}
	result = TRUE;
	_exif_entry_unref0 (width);
	_exif_entry_unref0 (height);
#line 192 "Exif.vala"
	return result;
#line 849 "Exif.c"
}


#line 197 "Exif.vala"
void exif_set_dimensions (ExifData** exif, Dimensions* dim) {
#line 855 "Exif.c"
	ExifEntry* width;
	ExifEntry* height;
#line 197 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 198 "Exif.vala"
	width = exif_find_entry_multiformat (*exif, EXIF_IFD_EXIF, EXIF_TAG_PIXEL_X_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 200 "Exif.vala"
	if (width == NULL) {
#line 864 "Exif.c"
		ExifEntry* _tmp0_;
#line 202 "Exif.vala"
		width = (_tmp0_ = exif_alloc_entry ((*exif)->ifd[0], EXIF_TAG_PIXEL_X_DIMENSION, EXIF_FORMAT_LONG), _exif_entry_unref0 (width), _tmp0_);
#line 868 "Exif.c"
	}
#line 205 "Exif.vala"
	height = exif_find_entry_multiformat (*exif, EXIF_IFD_EXIF, EXIF_TAG_PIXEL_Y_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 207 "Exif.vala"
	if (height == NULL) {
#line 874 "Exif.c"
		ExifEntry* _tmp1_;
#line 209 "Exif.vala"
		height = (_tmp1_ = exif_alloc_entry ((*exif)->ifd[0], EXIF_TAG_PIXEL_Y_DIMENSION, EXIF_FORMAT_LONG), _exif_entry_unref0 (height), _tmp1_);
#line 878 "Exif.c"
	}
#line 212 "Exif.vala"
	if (width->format == EXIF_FORMAT_SHORT) {
#line 213 "Exif.vala"
		exif_set_short (width->data, exif_data_get_byte_order (*exif), (guint16) (*dim).width);
#line 884 "Exif.c"
	} else {
#line 215 "Exif.vala"
		g_assert (width->format == EXIF_FORMAT_LONG);
#line 217 "Exif.vala"
		exif_set_long (width->data, exif_data_get_byte_order (*exif), (guint32) (*dim).width);
#line 890 "Exif.c"
	}
#line 220 "Exif.vala"
	if (height->format == EXIF_FORMAT_SHORT) {
#line 221 "Exif.vala"
		exif_set_short (height->data, exif_data_get_byte_order (*exif), (guint16) (*dim).height);
#line 896 "Exif.c"
	} else {
#line 223 "Exif.vala"
		g_assert (height->format == EXIF_FORMAT_LONG);
#line 225 "Exif.vala"
		exif_set_long (height->data, exif_data_get_byte_order (*exif), (guint32) (*dim).height);
#line 902 "Exif.c"
	}
	_exif_entry_unref0 (width);
	_exif_entry_unref0 (height);
}


#line 229 "Exif.vala"
char* exif_get_exposure (ExifData* exif) {
#line 911 "Exif.c"
	char* result;
	ExifEntry* entry;
	ExifRational exposure;
#line 229 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 230 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_EXIF, EXIF_TAG_EXPOSURE_TIME, EXIF_FORMAT_RATIONAL, 1);
#line 232 "Exif.vala"
	if (entry == NULL) {
#line 921 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 233 "Exif.vala"
		return result;
#line 926 "Exif.c"
	}
#line 235 "Exif.vala"
	exposure = exif_get_rational (entry->data, exif_data_get_byte_order (exif));
#line 237 "Exif.vala"
	if (exif_rational_to_double (exposure) >= 1) {
#line 932 "Exif.c"
		result = g_strdup_printf ("%.1f s", exif_rational_to_double (exposure));
		_exif_entry_unref0 (entry);
#line 238 "Exif.vala"
		return result;
#line 937 "Exif.c"
	} else {
		gint denominator;
#line 242 "Exif.vala"
		denominator = (gint) exposure.denominator;
#line 244 "Exif.vala"
		if (denominator > 10) {
#line 944 "Exif.c"
			gint off;
			gint _tmp0_ = 0;
#line 245 "Exif.vala"
			off = denominator % 5;
#line 246 "Exif.vala"
			if (off >= 3) {
#line 246 "Exif.vala"
				_tmp0_ = 5 - off;
#line 953 "Exif.c"
			} else {
#line 246 "Exif.vala"
				_tmp0_ = (-1) * off;
#line 957 "Exif.c"
			}
#line 246 "Exif.vala"
			denominator = denominator + _tmp0_;
#line 961 "Exif.c"
		}
		result = g_strdup_printf ("%d/%d s", (gint) exposure.numerator, denominator);
		_exif_entry_unref0 (entry);
#line 249 "Exif.vala"
		return result;
#line 967 "Exif.c"
	}
	_exif_entry_unref0 (entry);
}


#line 253 "Exif.vala"
char* exif_get_aperture (ExifData* exif) {
#line 975 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 253 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 254 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_EXIF, EXIF_TAG_FNUMBER, EXIF_FORMAT_RATIONAL, 1);
#line 256 "Exif.vala"
	if (entry == NULL) {
#line 987 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 257 "Exif.vala"
		return result;
#line 992 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 259 "Exif.vala"
	return result;
#line 998 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 262 "Exif.vala"
char* exif_get_iso (ExifData* exif) {
#line 1005 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 262 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 263 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_EXIF, EXIF_TAG_ISO_SPEED_RATINGS, EXIF_FORMAT_SHORT, 1);
#line 265 "Exif.vala"
	if (entry == NULL) {
#line 1017 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 266 "Exif.vala"
		return result;
#line 1022 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 268 "Exif.vala"
	return result;
#line 1028 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 271 "Exif.vala"
char* exif_get_camera_make (ExifData* exif) {
#line 1035 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 271 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 272 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_0, EXIF_TAG_MAKE, EXIF_FORMAT_ASCII, 1);
#line 274 "Exif.vala"
	if (entry == NULL) {
#line 1047 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 275 "Exif.vala"
		return result;
#line 1052 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 277 "Exif.vala"
	return result;
#line 1058 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 280 "Exif.vala"
char* exif_get_camera_model (ExifData* exif) {
#line 1065 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 280 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 281 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_0, EXIF_TAG_MODEL, EXIF_FORMAT_ASCII, 1);
#line 283 "Exif.vala"
	if (entry == NULL) {
#line 1077 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 284 "Exif.vala"
		return result;
#line 1082 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 286 "Exif.vala"
	return result;
#line 1088 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 290 "Exif.vala"
char* exif_get_flash (ExifData* exif) {
#line 1095 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 290 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 291 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_EXIF, EXIF_TAG_FLASH, EXIF_FORMAT_SHORT, 1);
#line 293 "Exif.vala"
	if (entry == NULL) {
#line 1107 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 294 "Exif.vala"
		return result;
#line 1112 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 296 "Exif.vala"
	return result;
#line 1118 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 300 "Exif.vala"
char* exif_get_focal_length (ExifData* exif) {
#line 1125 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 300 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 301 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_EXIF, EXIF_TAG_FOCAL_LENGTH, EXIF_FORMAT_RATIONAL, 1);
#line 304 "Exif.vala"
	if (entry == NULL) {
#line 1137 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 305 "Exif.vala"
		return result;
#line 1142 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 307 "Exif.vala"
	return result;
#line 1148 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 310 "Exif.vala"
ExifRational* exif_get_gps_rationals (ExifEntry* entry, ExifByteOrder byte_order, int* result_length1) {
#line 1155 "Exif.c"
	ExifRational* result;
	ExifRational* _tmp0_;
	gint rationals_size;
	gint rationals_length1;
	ExifRational* rationals;
	guchar* data;
	ExifRational* _tmp1_;
#line 310 "Exif.vala"
	g_return_val_if_fail (entry != NULL, NULL);
#line 1165 "Exif.c"
	rationals = (_tmp0_ = g_new0 (ExifRational, 3), rationals_length1 = 3, rationals_size = rationals_length1, _tmp0_);
#line 313 "Exif.vala"
	data = entry->data;
#line 315 "Exif.vala"
	rationals[0] = exif_get_rational (data, byte_order);
#line 316 "Exif.vala"
	data = data + exif_format_get_size (entry->format);
#line 317 "Exif.vala"
	rationals[1] = exif_get_rational (data, byte_order);
#line 318 "Exif.vala"
	data = data + exif_format_get_size (entry->format);
#line 319 "Exif.vala"
	rationals[2] = exif_get_rational (data, byte_order);
#line 1179 "Exif.c"
	result = (_tmp1_ = rationals, *result_length1 = rationals_length1, _tmp1_);
#line 321 "Exif.vala"
	return result;
#line 1183 "Exif.c"
	rationals = (g_free (rationals), NULL);
}


#line 324 "Exif.vala"
ExifRational* exif_get_raw_gps_lat (ExifData* exif, int* result_length1) {
#line 1190 "Exif.c"
	ExifRational* result;
	ExifEntry* entry;
	gint _tmp1_;
	ExifRational* _tmp2_;
#line 324 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 325 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_GPS, EXIF_TAG_GPS_LATITUDE, EXIF_FORMAT_RATIONAL, 3);
#line 328 "Exif.vala"
	if (entry == NULL) {
#line 1201 "Exif.c"
		gpointer _tmp0_;
		result = (_tmp0_ = NULL, *result_length1 = 0, _tmp0_);
		_exif_entry_unref0 (entry);
#line 329 "Exif.vala"
		return result;
#line 1207 "Exif.c"
	}
	result = (_tmp2_ = exif_get_gps_rationals (entry, exif_data_get_byte_order (exif), &_tmp1_), *result_length1 = _tmp1_, _tmp2_);
	_exif_entry_unref0 (entry);
#line 331 "Exif.vala"
	return result;
#line 1213 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 334 "Exif.vala"
ExifRational* exif_get_raw_gps_long (ExifData* exif, int* result_length1) {
#line 1220 "Exif.c"
	ExifRational* result;
	ExifEntry* entry;
	gint _tmp1_;
	ExifRational* _tmp2_;
#line 334 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 335 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_GPS, EXIF_TAG_GPS_LONGITUDE, EXIF_FORMAT_RATIONAL, 3);
#line 338 "Exif.vala"
	if (entry == NULL) {
#line 1231 "Exif.c"
		gpointer _tmp0_;
		result = (_tmp0_ = NULL, *result_length1 = 0, _tmp0_);
		_exif_entry_unref0 (entry);
#line 339 "Exif.vala"
		return result;
#line 1237 "Exif.c"
	}
	result = (_tmp2_ = exif_get_gps_rationals (entry, exif_data_get_byte_order (exif), &_tmp1_), *result_length1 = _tmp1_, _tmp2_);
	_exif_entry_unref0 (entry);
#line 341 "Exif.vala"
	return result;
#line 1243 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 344 "Exif.vala"
double exif_get_angle (ExifRational* rationals, int rationals_length1) {
#line 1250 "Exif.c"
	double result;
	result = (exif_rational_to_double (rationals[0]) + ((1.0 / 60.0) * exif_rational_to_double (rationals[1]))) + ((1.0 / 360.0) * exif_rational_to_double (rationals[2]));
#line 345 "Exif.vala"
	return result;
#line 1255 "Exif.c"
}


#line 349 "Exif.vala"
double exif_get_gps_lat (ExifData* exif) {
#line 1261 "Exif.c"
	double result;
	ExifRational* _tmp1_;
	gint rationals_size;
	gint rationals_length1;
	gint _tmp0_;
	ExifRational* rationals;
#line 349 "Exif.vala"
	g_return_val_if_fail (exif != NULL, 0.0);
#line 1270 "Exif.c"
	rationals = (_tmp1_ = exif_get_raw_gps_lat (exif, &_tmp0_), rationals_length1 = _tmp0_, rationals_size = rationals_length1, _tmp1_);
#line 351 "Exif.vala"
	if (rationals == NULL) {
#line 1274 "Exif.c"
		result = (double) (-1);
		rationals = (g_free (rationals), NULL);
#line 352 "Exif.vala"
		return result;
#line 1279 "Exif.c"
	}
	result = exif_get_angle (rationals, rationals_length1);
	rationals = (g_free (rationals), NULL);
#line 354 "Exif.vala"
	return result;
#line 1285 "Exif.c"
}


#line 357 "Exif.vala"
double exif_get_gps_long (ExifData* exif) {
#line 1291 "Exif.c"
	double result;
	ExifRational* _tmp1_;
	gint rationals_size;
	gint rationals_length1;
	gint _tmp0_;
	ExifRational* rationals;
#line 357 "Exif.vala"
	g_return_val_if_fail (exif != NULL, 0.0);
#line 1300 "Exif.c"
	rationals = (_tmp1_ = exif_get_raw_gps_long (exif, &_tmp0_), rationals_length1 = _tmp0_, rationals_size = rationals_length1, _tmp1_);
#line 360 "Exif.vala"
	if (rationals == NULL) {
#line 1304 "Exif.c"
		result = (double) (-1);
		rationals = (g_free (rationals), NULL);
#line 361 "Exif.vala"
		return result;
#line 1309 "Exif.c"
	}
	result = exif_get_angle (rationals, rationals_length1);
	rationals = (g_free (rationals), NULL);
#line 363 "Exif.vala"
	return result;
#line 1315 "Exif.c"
}


#line 366 "Exif.vala"
char* exif_get_gps_lat_ref (ExifData* exif) {
#line 1321 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 366 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 367 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_GPS, EXIF_TAG_GPS_LATITUDE_REF, EXIF_FORMAT_ASCII, 1);
#line 370 "Exif.vala"
	if (entry == NULL) {
#line 1333 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 371 "Exif.vala"
		return result;
#line 1338 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 373 "Exif.vala"
	return result;
#line 1344 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 376 "Exif.vala"
char* exif_get_gps_long_ref (ExifData* exif) {
#line 1351 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 376 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 377 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_GPS, EXIF_TAG_GPS_LONGITUDE_REF, EXIF_FORMAT_ASCII, 1);
#line 380 "Exif.vala"
	if (entry == NULL) {
#line 1363 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 381 "Exif.vala"
		return result;
#line 1368 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 383 "Exif.vala"
	return result;
#line 1374 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 386 "Exif.vala"
char* exif_get_artist (ExifData* exif) {
#line 1381 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 386 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 387 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_0, EXIF_TAG_ARTIST, EXIF_FORMAT_ASCII, 1);
#line 389 "Exif.vala"
	if (entry == NULL) {
#line 1393 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 390 "Exif.vala"
		return result;
#line 1398 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 392 "Exif.vala"
	return result;
#line 1404 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 395 "Exif.vala"
char* exif_get_copyright (ExifData* exif) {
#line 1411 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 395 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 396 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_0, EXIF_TAG_COPYRIGHT, EXIF_FORMAT_ASCII, 1);
#line 398 "Exif.vala"
	if (entry == NULL) {
#line 1423 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 399 "Exif.vala"
		return result;
#line 1428 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 401 "Exif.vala"
	return result;
#line 1434 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 404 "Exif.vala"
char* exif_get_software (ExifData* exif) {
#line 1441 "Exif.c"
	char* result;
	ExifEntry* entry;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 404 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 405 "Exif.vala"
	entry = exif_find_entry (exif, EXIF_IFD_0, EXIF_TAG_SOFTWARE, EXIF_FORMAT_ASCII, 1);
#line 407 "Exif.vala"
	if (entry == NULL) {
#line 1453 "Exif.c"
		result = g_strdup ("");
		_exif_entry_unref0 (entry);
#line 408 "Exif.vala"
		return result;
#line 1458 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (entry, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (entry);
#line 410 "Exif.vala"
	return result;
#line 1464 "Exif.c"
	_exif_entry_unref0 (entry);
}


GQuark exif_error_quark (void) {
	return g_quark_from_static_string ("exif_error-quark");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 425 "Exif.vala"
PhotoExif* photo_exif_construct (GType object_type, GFile* file) {
#line 1481 "Exif.c"
	PhotoExif* self;
	GFile* _tmp0_;
#line 425 "Exif.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1486 "Exif.c"
	self = (PhotoExif*) g_type_create_instance (object_type);
#line 426 "Exif.vala"
	self->priv->file = (_tmp0_ = _g_object_ref0 (file), _g_object_unref0 (self->priv->file), _tmp0_);
#line 1490 "Exif.c"
	return self;
}


#line 425 "Exif.vala"
PhotoExif* photo_exif_new (GFile* file) {
#line 425 "Exif.vala"
	return photo_exif_construct (TYPE_PHOTO_EXIF, file);
#line 1499 "Exif.c"
}


#line 429 "Exif.vala"
gboolean photo_exif_has_exif (PhotoExif* self) {
#line 1505 "Exif.c"
	gboolean result;
	GError * _inner_error_;
#line 429 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 1510 "Exif.c"
	_inner_error_ = NULL;
	{
		gsize raw_length = 0UL;
		guint8* _tmp2_;
		gint _tmp1__size;
		gint _tmp1__length1;
		gint _tmp0_;
		guint8* _tmp1_;
		gint _tmp3__length1;
		guint8* _tmp3_;
		gboolean _tmp4_;
		_tmp1_ = (_tmp2_ = photo_exif_get_raw_exif (self, &raw_length, &_tmp0_, &_inner_error_), _tmp1__length1 = _tmp0_, _tmp1__size = _tmp1__length1, _tmp2_);
		if (_inner_error_ != NULL) {
			goto __catch25_g_error;
			goto __finally25;
		}
		result = (_tmp4_ = (_tmp3_ = _tmp1_, _tmp3__length1 = _tmp1__length1, _tmp3_) != NULL, _tmp3_ = (g_free (_tmp3_), NULL), _tmp4_);
#line 434 "Exif.vala"
		return result;
#line 1530 "Exif.c"
	}
	goto __finally25;
	__catch25_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp5_;
#line 436 "Exif.vala"
			g_warning ("Exif.vala:436: Unable to load EXIF from %s: %s", _tmp5_ = g_file_get_path (self->priv->file), err->message);
#line 1542 "Exif.c"
			_g_free0 (_tmp5_);
			result = FALSE;
			_g_error_free0 (err);
#line 438 "Exif.vala"
			return result;
#line 1548 "Exif.c"
		}
	}
	__finally25:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 443 "Exif.vala"
guint8* photo_exif_get_raw_exif (PhotoExif* self, gsize* raw_length, int* result_length1, GError** error) {
#line 1562 "Exif.c"
	guint8* result;
	GError * _inner_error_;
	GFileInputStream* fins;
	JpegMarker marker = 0;
	gint segment_length = 0;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	guint8* _tmp5_;
	gint raw_size;
	gint raw_length1;
	guint8* raw;
	guint8* _tmp16_;
#line 443 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 1577 "Exif.c"
	_inner_error_ = NULL;
#line 444 "Exif.vala"
	photo_exif_update (self);
#line 446 "Exif.vala"
	if (self->priv->no_exif) {
#line 1583 "Exif.c"
		gpointer _tmp0_;
		result = (_tmp0_ = NULL, *result_length1 = 0, _tmp0_);
#line 447 "Exif.vala"
		return result;
#line 1588 "Exif.c"
	}
#line 449 "Exif.vala"
	fins = g_file_read (self->priv->file, NULL, &_inner_error_);
#line 1592 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
#line 455 "Exif.vala"
	_tmp1_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 1599 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return NULL;
	}
#line 455 "Exif.vala"
	segment_length = _tmp1_;
#line 456 "Exif.vala"
	if (marker != JPEG_MARKER_SOI) {
#line 456 "Exif.vala"
		_tmp2_ = TRUE;
#line 1611 "Exif.c"
	} else {
#line 456 "Exif.vala"
		_tmp2_ = segment_length != 0;
#line 1615 "Exif.c"
	}
#line 456 "Exif.vala"
	if (_tmp2_) {
#line 1619 "Exif.c"
		char* _tmp3_;
		gpointer _tmp4_;
#line 457 "Exif.vala"
		g_warning ("Exif.vala:457: No SOI marker found in %s", _tmp3_ = g_file_get_path (self->priv->file));
#line 1624 "Exif.c"
		_g_free0 (_tmp3_);
		result = (_tmp4_ = NULL, *result_length1 = 0, _tmp4_);
		_g_object_unref0 (fins);
#line 459 "Exif.vala"
		return result;
#line 1630 "Exif.c"
	}
	raw = (_tmp5_ = NULL, raw_length1 = 0, raw_size = raw_length1, _tmp5_);
	{
		gboolean _tmp6_;
#line 464 "Exif.vala"
		_tmp6_ = TRUE;
#line 464 "Exif.vala"
		while (TRUE) {
#line 1639 "Exif.c"
			gint _tmp7_;
			gboolean _tmp9_ = FALSE;
			guint8* _tmp11_;
			gsize bytes_read = 0UL;
#line 464 "Exif.vala"
			if (!_tmp6_) {
#line 1646 "Exif.c"
			}
#line 464 "Exif.vala"
			_tmp6_ = FALSE;
#line 465 "Exif.vala"
			_tmp7_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 1652 "Exif.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (fins);
				raw = (g_free (raw), NULL);
				return NULL;
			}
#line 465 "Exif.vala"
			segment_length = _tmp7_;
#line 466 "Exif.vala"
			if (segment_length == (-1)) {
#line 1663 "Exif.c"
				gpointer _tmp8_;
				result = (_tmp8_ = NULL, *result_length1 = 0, _tmp8_);
				_g_object_unref0 (fins);
				raw = (g_free (raw), NULL);
#line 468 "Exif.vala"
				return result;
#line 1670 "Exif.c"
			}
#line 471 "Exif.vala"
			if (marker != JPEG_MARKER_APP1) {
#line 471 "Exif.vala"
				_tmp9_ = TRUE;
#line 1676 "Exif.c"
			} else {
#line 471 "Exif.vala"
				_tmp9_ = segment_length < G_N_ELEMENTS (EXIF_SIGNATURE);
#line 1680 "Exif.c"
			}
#line 471 "Exif.vala"
			if (_tmp9_) {
#line 472 "Exif.vala"
				if (segment_length > 0) {
#line 473 "Exif.vala"
					g_input_stream_skip (G_INPUT_STREAM (fins), (gsize) segment_length, NULL, &_inner_error_);
#line 1688 "Exif.c"
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						_g_object_unref0 (fins);
						raw = (g_free (raw), NULL);
						return NULL;
					}
				}
#line 475 "Exif.vala"
				continue;
#line 1698 "Exif.c"
			}
#line 481 "Exif.vala"
			*raw_length = (gsize) (segment_length - self->priv->exif->size);
#line 482 "Exif.vala"
			if ((*raw_length) <= 0) {
#line 1704 "Exif.c"
				char* _tmp10_;
#line 483 "Exif.vala"
				g_warning ("Exif.vala:483: No EXIF data to read in APP1 segment of %s", _tmp10_ = g_file_get_path (self->priv->file));
#line 1708 "Exif.c"
				_g_free0 (_tmp10_);
#line 485 "Exif.vala"
				if (segment_length > 0) {
#line 486 "Exif.vala"
					g_input_stream_skip (G_INPUT_STREAM (fins), (gsize) segment_length, NULL, &_inner_error_);
#line 1714 "Exif.c"
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						_g_object_unref0 (fins);
						raw = (g_free (raw), NULL);
						return NULL;
					}
				}
#line 488 "Exif.vala"
				continue;
#line 1724 "Exif.c"
			}
#line 491 "Exif.vala"
			raw = (_tmp11_ = g_new0 (guint8, *raw_length), raw = (g_free (raw), NULL), raw_length1 = *raw_length, raw_size = raw_length1, _tmp11_);
#line 494 "Exif.vala"
			g_input_stream_read_all (G_INPUT_STREAM (fins), raw, (gsize) raw_length1, &bytes_read, NULL, &_inner_error_);
#line 1730 "Exif.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (fins);
				raw = (g_free (raw), NULL);
				return NULL;
			}
#line 495 "Exif.vala"
			if (bytes_read != raw_length1) {
#line 1739 "Exif.c"
				char* _tmp12_;
#line 496 "Exif.vala"
				g_warning ("Exif.vala:496: Unable to read full segment in %s", _tmp12_ = g_file_get_path (self->priv->file));
#line 1743 "Exif.c"
				_g_free0 (_tmp12_);
#line 500 "Exif.vala"
				continue;
#line 1747 "Exif.c"
			}
#line 504 "Exif.vala"
			if (memcmp (raw, EXIF_SIGNATURE, (gsize) G_N_ELEMENTS (EXIF_SIGNATURE)) != 0) {
#line 1751 "Exif.c"
				char* _tmp13_;
#line 505 "Exif.vala"
				g_warning ("Exif.vala:505: Invalid EXIF signature in APP1 segment of %s", _tmp13_ = g_file_get_path (self->priv->file));
#line 1755 "Exif.c"
				_g_free0 (_tmp13_);
#line 507 "Exif.vala"
				continue;
#line 1759 "Exif.c"
			}
#line 511 "Exif.vala"
			break;
#line 1763 "Exif.c"
		}
	}
#line 514 "Exif.vala"
	if (marker != JPEG_MARKER_APP1) {
#line 1768 "Exif.c"
		char* _tmp14_;
		gpointer _tmp15_;
#line 515 "Exif.vala"
		g_warning ("Exif.vala:515: No APP1 marker found in %s", _tmp14_ = g_file_get_path (self->priv->file));
#line 1773 "Exif.c"
		_g_free0 (_tmp14_);
		result = (_tmp15_ = NULL, *result_length1 = 0, _tmp15_);
		_g_object_unref0 (fins);
		raw = (g_free (raw), NULL);
#line 517 "Exif.vala"
		return result;
#line 1780 "Exif.c"
	}
#line 524 "Exif.vala"
	if (raw[(*raw_length) - 2] == JPEG_MARKER_PREFIX) {
#line 525 "Exif.vala"
		*raw_length = (*raw_length) - ((gsize) 2);
#line 1786 "Exif.c"
	}
	result = (_tmp16_ = raw, *result_length1 = raw_length1, _tmp16_);
	_g_object_unref0 (fins);
#line 527 "Exif.vala"
	return result;
#line 1792 "Exif.c"
	_g_object_unref0 (fins);
	raw = (g_free (raw), NULL);
}


#line 531 "Exif.vala"
char* photo_exif_get_md5 (PhotoExif* self) {
#line 1800 "Exif.c"
	char* result;
	GError * _inner_error_;
	gsize raw_length = 0UL;
	guint8* _tmp0_;
	gint raw_size;
	gint raw_length1;
	guint8* raw;
	gboolean _tmp6_ = FALSE;
#line 531 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 1811 "Exif.c"
	_inner_error_ = NULL;
	raw = (_tmp0_ = NULL, raw_length1 = 0, raw_size = raw_length1, _tmp0_);
	{
		guint8* _tmp3_;
		gint _tmp2__size;
		gint _tmp2__length1;
		gint _tmp1_;
		guint8* _tmp2_;
		guint8* _tmp4_;
		_tmp2_ = (_tmp3_ = photo_exif_get_raw_exif (self, &raw_length, &_tmp1_, &_inner_error_), _tmp2__length1 = _tmp1_, _tmp2__size = _tmp2__length1, _tmp3_);
		if (_inner_error_ != NULL) {
			goto __catch26_g_error;
			goto __finally26;
		}
#line 536 "Exif.vala"
		raw = (_tmp4_ = _tmp2_, raw = (g_free (raw), NULL), raw_length1 = _tmp2__length1, raw_size = raw_length1, _tmp4_);
#line 1828 "Exif.c"
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp5_;
#line 538 "Exif.vala"
			g_warning ("Exif.vala:538: Unable to get EXIF to calculate checksum for %s: %s", _tmp5_ = g_file_get_path (self->priv->file), err->message);
#line 1840 "Exif.c"
			_g_free0 (_tmp5_);
			_g_error_free0 (err);
		}
	}
	__finally26:
	if (_inner_error_ != NULL) {
		raw = (g_free (raw), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
#line 542 "Exif.vala"
	if (raw == NULL) {
#line 542 "Exif.vala"
		_tmp6_ = TRUE;
#line 1856 "Exif.c"
	} else {
#line 542 "Exif.vala"
		_tmp6_ = raw_length <= 0;
#line 1860 "Exif.c"
	}
#line 542 "Exif.vala"
	if (_tmp6_) {
#line 1864 "Exif.c"
		result = NULL;
		raw = (g_free (raw), NULL);
#line 543 "Exif.vala"
		return result;
#line 1869 "Exif.c"
	}
	result = md5_binary (raw, raw_length);
	raw = (g_free (raw), NULL);
#line 545 "Exif.vala"
	return result;
#line 1875 "Exif.c"
}


#line 549 "Exif.vala"
char* photo_exif_get_thumbnail_md5 (PhotoExif* self) {
#line 1881 "Exif.c"
	char* result;
	ExifData* data;
	gboolean _tmp0_ = FALSE;
#line 549 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 550 "Exif.vala"
	data = photo_exif_get_exif (self);
#line 551 "Exif.vala"
	if (data == NULL) {
#line 1891 "Exif.c"
		result = NULL;
		_exif_data_unref0 (data);
#line 552 "Exif.vala"
		return result;
#line 1896 "Exif.c"
	}
#line 554 "Exif.vala"
	if (data->data == NULL) {
#line 554 "Exif.vala"
		_tmp0_ = TRUE;
#line 1902 "Exif.c"
	} else {
#line 554 "Exif.vala"
		_tmp0_ = data->size <= 0;
#line 1906 "Exif.c"
	}
#line 554 "Exif.vala"
	if (_tmp0_) {
#line 1910 "Exif.c"
		result = NULL;
		_exif_data_unref0 (data);
#line 555 "Exif.vala"
		return result;
#line 1915 "Exif.c"
	}
	result = md5_binary (data->data, (gsize) data->size);
	_exif_data_unref0 (data);
#line 557 "Exif.vala"
	return result;
#line 1921 "Exif.c"
}


#line 560 "Exif.vala"
ExifData* photo_exif_get_exif (PhotoExif* self) {
#line 1927 "Exif.c"
	ExifData* result;
	ExifData* _tmp1_;
#line 560 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 561 "Exif.vala"
	if (self->priv->exif != NULL) {
#line 1934 "Exif.c"
		ExifData* _tmp0_;
		result = (_tmp0_ = self->priv->exif, (_tmp0_ == NULL) ? NULL : exif_data_ref (_tmp0_), _tmp0_);
#line 562 "Exif.vala"
		return result;
#line 1939 "Exif.c"
	}
#line 564 "Exif.vala"
	if (!photo_exif_has_exif (self)) {
#line 1943 "Exif.c"
		result = NULL;
#line 565 "Exif.vala"
		return result;
#line 1947 "Exif.c"
	}
#line 567 "Exif.vala"
	photo_exif_update (self);
#line 1951 "Exif.c"
	result = (_tmp1_ = self->priv->exif, (_tmp1_ == NULL) ? NULL : exif_data_ref (_tmp1_), _tmp1_);
#line 569 "Exif.vala"
	return result;
#line 1955 "Exif.c"
}


#line 572 "Exif.vala"
void photo_exif_set_exif (PhotoExif* self, ExifData* exif) {
#line 1961 "Exif.c"
	ExifData* _tmp1_;
	ExifData* _tmp0_;
#line 572 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 572 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 573 "Exif.vala"
	self->priv->exif = (_tmp1_ = (_tmp0_ = exif, (_tmp0_ == NULL) ? NULL : exif_data_ref (_tmp0_), _tmp0_), _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 574 "Exif.vala"
	self->priv->no_exif = FALSE;
#line 1972 "Exif.c"
}


#line 577 "Exif.vala"
Orientation photo_exif_get_orientation (PhotoExif* self) {
#line 1978 "Exif.c"
	Orientation result;
#line 577 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), 0);
#line 578 "Exif.vala"
	photo_exif_update (self);
#line 1984 "Exif.c"
	result = exif_get_orientation (self->priv->exif);
#line 580 "Exif.vala"
	return result;
#line 1988 "Exif.c"
}


#line 583 "Exif.vala"
void photo_exif_set_orientation (PhotoExif* self, Orientation orientation) {
#line 583 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 584 "Exif.vala"
	photo_exif_update (self);
#line 586 "Exif.vala"
	exif_set_orientation (&self->priv->exif, orientation);
#line 2000 "Exif.c"
}


#line 589 "Exif.vala"
gboolean photo_exif_get_dimensions (PhotoExif* self, Dimensions* dim) {
#line 2006 "Exif.c"
	gboolean result;
#line 589 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 590 "Exif.vala"
	photo_exif_update (self);
#line 2012 "Exif.c"
	result = exif_get_dimensions (self->priv->exif, dim);
#line 592 "Exif.vala"
	return result;
#line 2016 "Exif.c"
}


#line 595 "Exif.vala"
void photo_exif_set_dimensions (PhotoExif* self, Dimensions* dim) {
#line 595 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 596 "Exif.vala"
	photo_exif_update (self);
#line 598 "Exif.vala"
	exif_set_dimensions (&self->priv->exif, dim);
#line 2028 "Exif.c"
}


#line 601 "Exif.vala"
char* photo_exif_get_datetime (PhotoExif* self) {
#line 2034 "Exif.c"
	char* result;
	ExifEntry* datetime;
	gint _tmp0__length1;
	gchar* _tmp0_;
	char* _tmp1_;
#line 601 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 602 "Exif.vala"
	photo_exif_update (self);
#line 604 "Exif.vala"
	datetime = exif_find_entry (self->priv->exif, EXIF_IFD_EXIF, EXIF_TAG_DATE_TIME_ORIGINAL, EXIF_FORMAT_ASCII, 1);
#line 605 "Exif.vala"
	if (datetime == NULL) {
#line 2048 "Exif.c"
		result = NULL;
		_exif_entry_unref0 (datetime);
#line 606 "Exif.vala"
		return result;
#line 2053 "Exif.c"
	}
	result = (_tmp1_ = g_strdup (exif_entry_get_value (datetime, (_tmp0_ = g_new0 (gchar, 256), _tmp0__length1 = 256, _tmp0_), 256)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	_exif_entry_unref0 (datetime);
#line 608 "Exif.vala"
	return result;
#line 2059 "Exif.c"
	_exif_entry_unref0 (datetime);
}


#line 611 "Exif.vala"
gboolean photo_exif_get_timestamp (PhotoExif* self, time_t* timestamp) {
#line 2066 "Exif.c"
	gboolean result;
	char* datetime;
#line 611 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 612 "Exif.vala"
	datetime = photo_exif_get_datetime (self);
#line 613 "Exif.vala"
	if (datetime == NULL) {
#line 2075 "Exif.c"
		result = FALSE;
		_g_free0 (datetime);
#line 614 "Exif.vala"
		return result;
#line 2080 "Exif.c"
	}
	result = exif_convert_datetime (datetime, timestamp);
	_g_free0 (datetime);
#line 616 "Exif.vala"
	return result;
#line 2086 "Exif.c"
}


#line 619 "Exif.vala"
gint photo_exif_remove_all_tags (PhotoExif* self, ExifTag tag) {
#line 2092 "Exif.c"
	gint result;
#line 619 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), 0);
#line 620 "Exif.vala"
	photo_exif_update (self);
#line 622 "Exif.vala"
	if (self->priv->exif == NULL) {
#line 2100 "Exif.c"
		result = 0;
#line 623 "Exif.vala"
		return result;
#line 2104 "Exif.c"
	}
	result = exif_remove_all_tags (self->priv->exif, tag);
#line 625 "Exif.vala"
	return result;
#line 2109 "Exif.c"
}


#line 628 "Exif.vala"
gboolean photo_exif_remove_thumbnail (PhotoExif* self) {
#line 2115 "Exif.c"
	gboolean result;
#line 628 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 629 "Exif.vala"
	photo_exif_update (self);
#line 631 "Exif.vala"
	if (self->priv->exif == NULL) {
#line 2123 "Exif.c"
		result = FALSE;
#line 632 "Exif.vala"
		return result;
#line 2127 "Exif.c"
	}
#line 634 "Exif.vala"
	if (self->priv->exif->data == NULL) {
#line 2131 "Exif.c"
		result = FALSE;
#line 635 "Exif.vala"
		return result;
#line 2135 "Exif.c"
	}
#line 637 "Exif.vala"
	free (self->priv->exif->data);
#line 638 "Exif.vala"
	self->priv->exif->data = NULL;
#line 639 "Exif.vala"
	self->priv->exif->size = (guint) 0;
#line 2143 "Exif.c"
	result = TRUE;
#line 641 "Exif.vala"
	return result;
#line 2147 "Exif.c"
}


#line 644 "Exif.vala"
static void photo_exif_update (PhotoExif* self) {
#line 2153 "Exif.c"
	ExifData* _tmp1_;
	char* _tmp0_;
#line 644 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 645 "Exif.vala"
	if (self->priv->no_exif) {
#line 646 "Exif.vala"
		return;
#line 2162 "Exif.c"
	}
#line 649 "Exif.vala"
	if (self->priv->exif != NULL) {
#line 650 "Exif.vala"
		return;
#line 2168 "Exif.c"
	}
#line 652 "Exif.vala"
	self->priv->exif = (_tmp1_ = exif_data_new_from_file (_tmp0_ = g_file_get_path (self->priv->file)), _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 2172 "Exif.c"
	_g_free0 (_tmp0_);
#line 653 "Exif.vala"
	if (self->priv->exif == NULL) {
#line 654 "Exif.vala"
		self->priv->no_exif = TRUE;
#line 656 "Exif.vala"
		return;
#line 2180 "Exif.c"
	}
#line 660 "Exif.vala"
	exif_data_fix (self->priv->exif);
#line 2184 "Exif.c"
}


#line 663 "Exif.vala"
void photo_exif_commit (PhotoExif* self, GError** error) {
#line 2190 "Exif.c"
	GError * _inner_error_;
	GFileInputStream* fins;
	JpegMarker marker = 0;
	gint segment_length = 0;
	gboolean original_has_exif;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp5_;
	guchar* flattened;
	gint flattened_size;
#line 663 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 2203 "Exif.c"
	_inner_error_ = NULL;
#line 664 "Exif.vala"
	if (self->priv->exif == NULL) {
#line 665 "Exif.vala"
		return;
#line 2209 "Exif.c"
	}
#line 667 "Exif.vala"
	fins = g_file_read (self->priv->file, NULL, &_inner_error_);
#line 2213 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 671 "Exif.vala"
	original_has_exif = TRUE;
#line 674 "Exif.vala"
	_tmp0_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 2222 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return;
	}
#line 674 "Exif.vala"
	segment_length = _tmp0_;
#line 675 "Exif.vala"
	if (marker != JPEG_MARKER_SOI) {
#line 675 "Exif.vala"
		_tmp1_ = TRUE;
#line 2234 "Exif.c"
	} else {
#line 675 "Exif.vala"
		_tmp1_ = segment_length != 0;
#line 2238 "Exif.c"
	}
#line 675 "Exif.vala"
	if (_tmp1_) {
#line 2242 "Exif.c"
		char* _tmp3_;
		char* _tmp2_;
		GError* _tmp4_;
		_inner_error_ = (_tmp4_ = g_error_new_literal (EXIF_ERROR, EXIF_ERROR_FILE_FORMAT, _tmp3_ = g_strdup_printf ("SOI not found in %s", _tmp2_ = g_file_get_path (self->priv->file))), _g_free0 (_tmp3_), _g_free0 (_tmp2_), _tmp4_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (fins);
			return;
		}
	}
#line 679 "Exif.vala"
	_tmp5_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 2255 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return;
	}
#line 679 "Exif.vala"
	segment_length = _tmp5_;
#line 680 "Exif.vala"
	if (segment_length <= 0) {
#line 2265 "Exif.c"
		char* _tmp6_;
		GError* _tmp7_;
		_inner_error_ = (_tmp7_ = g_error_new_literal (EXIF_ERROR, EXIF_ERROR_FILE_FORMAT, _tmp6_ = g_strdup_printf ("EXIF APP1 length of %d", segment_length)), _g_free0 (_tmp6_), _tmp7_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (fins);
			return;
		}
	}
#line 682 "Exif.vala"
	if (marker != JPEG_MARKER_APP1) {
#line 683 "Exif.vala"
		original_has_exif = FALSE;
#line 2279 "Exif.c"
	}
#line 686 "Exif.vala"
	flattened = NULL;
#line 687 "Exif.vala"
	flattened_size = 0;
#line 688 "Exif.vala"
	exif_data_save_data (self->priv->exif, &flattened, &flattened_size);
#line 689 "Exif.vala"
	g_assert (flattened != NULL);
#line 690 "Exif.vala"
	g_assert (flattened_size > 0);
#line 2291 "Exif.c"
	{
		gboolean _tmp8_ = FALSE;
#line 693 "Exif.vala"
		if (flattened_size == segment_length) {
#line 693 "Exif.vala"
			_tmp8_ = original_has_exif;
#line 2298 "Exif.c"
		} else {
#line 693 "Exif.vala"
			_tmp8_ = FALSE;
#line 2302 "Exif.c"
		}
#line 693 "Exif.vala"
		if (_tmp8_) {
#line 2306 "Exif.c"
			char* _tmp9_;
			GFileInputStream* _tmp10_;
			char* _tmp11_;
			FILE* _tmp12_;
			FILE* fs;
			gsize count_written;
#line 697 "Exif.vala"
			g_debug ("Exif.vala:697: Writing EXIF in-place of %d bytes to %s", flattened_size, _tmp9_ = g_file_get_path (self->priv->file));
#line 2315 "Exif.c"
			_g_free0 (_tmp9_);
#line 700 "Exif.vala"
			g_input_stream_close (G_INPUT_STREAM (fins), NULL, &_inner_error_);
#line 2319 "Exif.c"
			if (_inner_error_ != NULL) {
				goto __finally27;
			}
#line 701 "Exif.vala"
			fins = (_tmp10_ = NULL, _g_object_unref0 (fins), _tmp10_);
#line 705 "Exif.vala"
			fs = (_tmp12_ = fopen (_tmp11_ = g_file_get_path (self->priv->file), "r+"), _g_free0 (_tmp11_), _tmp12_);
#line 706 "Exif.vala"
			if (fs == NULL) {
#line 2329 "Exif.c"
				char* _tmp14_;
				char* _tmp13_;
				GError* _tmp15_;
				_inner_error_ = (_tmp15_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp14_ = g_strdup_printf ("%s: fopen() error", _tmp13_ = g_file_get_path (self->priv->file))), _g_free0 (_tmp14_), _g_free0 (_tmp13_), _tmp15_);
				if (_inner_error_ != NULL) {
					_fclose0 (fs);
					goto __finally27;
				}
			}
#line 710 "Exif.vala"
			if (fseek (fs, (glong) ((2 + 2) + 2), SEEK_SET) < 0) {
#line 2341 "Exif.c"
				char* _tmp16_;
				GError* _tmp17_;
				_inner_error_ = (_tmp17_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "%s: fseek() error %d", _tmp16_ = g_file_get_path (self->priv->file), ferror (fs)), _g_free0 (_tmp16_), _tmp17_);
				if (_inner_error_ != NULL) {
					_fclose0 (fs);
					goto __finally27;
				}
			}
#line 714 "Exif.vala"
			count_written = fwrite (flattened, (gsize) flattened_size, (gsize) 1, fs);
#line 715 "Exif.vala"
			if (count_written != 1) {
#line 2354 "Exif.c"
				char* _tmp18_;
				GError* _tmp19_;
				_inner_error_ = (_tmp19_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "%s: fwrite() error %d", _tmp18_ = g_file_get_path (self->priv->file), errno), _g_free0 (_tmp18_), _tmp19_);
				if (_inner_error_ != NULL) {
					_fclose0 (fs);
					goto __finally27;
				}
			}
			_fclose0 (fs);
		} else {
			GFile* temp;
			GFile* _tmp22_;
			GFileOutputStream* _tmp21_;
			GFile* _tmp20_ = NULL;
			GFileOutputStream* fouts;
			gsize bytes_written;
			char* _tmp24_;
			char* _tmp23_;
			guint8* _tmp25_;
			gint copy_buffer_size;
			gint copy_buffer_length1;
			guint8* copy_buffer;
#line 721 "Exif.vala"
			if (original_has_exif) {
#line 722 "Exif.vala"
				g_input_stream_skip (G_INPUT_STREAM (fins), (gsize) segment_length, NULL, &_inner_error_);
#line 2381 "Exif.c"
				if (_inner_error_ != NULL) {
					goto __finally27;
				}
			}
#line 724 "Exif.vala"
			temp = NULL;
#line 725 "Exif.vala"
			fouts = (_tmp21_ = photo_exif_create_temp (self->priv->file, &_tmp20_, &_inner_error_), temp = (_tmp22_ = _tmp20_, _g_object_unref0 (temp), _tmp22_), _tmp21_);
#line 2390 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				goto __finally27;
			}
#line 726 "Exif.vala"
			bytes_written = (gsize) 0;
#line 728 "Exif.vala"
			g_debug ("Exif.vala:728: Building new file at %s with %d bytes EXIF, overwriting %s", _tmp23_ = g_file_get_path (temp), flattened_size, _tmp24_ = g_file_get_path (self->priv->file));
#line 2399 "Exif.c"
			_g_free0 (_tmp24_);
			_g_free0 (_tmp23_);
#line 732 "Exif.vala"
			jpeg_write_marker (fouts, JPEG_MARKER_SOI, 0, &_inner_error_);
#line 2404 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				goto __finally27;
			}
#line 735 "Exif.vala"
			jpeg_write_marker (fouts, JPEG_MARKER_APP1, flattened_size, &_inner_error_);
#line 2412 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				goto __finally27;
			}
#line 736 "Exif.vala"
			g_output_stream_write_all (G_OUTPUT_STREAM (fouts), flattened, (gsize) flattened_size, &bytes_written, NULL, &_inner_error_);
#line 2420 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				goto __finally27;
			}
#line 737 "Exif.vala"
			g_assert (bytes_written == flattened_size);
#line 740 "Exif.vala"
			if (!original_has_exif) {
#line 742 "Exif.vala"
				if (marker != JPEG_MARKER_APP0) {
#line 743 "Exif.vala"
					jpeg_write_marker (fouts, marker, segment_length, &_inner_error_);
#line 2434 "Exif.c"
					if (_inner_error_ != NULL) {
						_g_object_unref0 (temp);
						_g_object_unref0 (fouts);
						goto __finally27;
					}
				} else {
#line 745 "Exif.vala"
					g_input_stream_skip (G_INPUT_STREAM (fins), (gsize) segment_length, NULL, &_inner_error_);
#line 2443 "Exif.c"
					if (_inner_error_ != NULL) {
						_g_object_unref0 (temp);
						_g_object_unref0 (fouts);
						goto __finally27;
					}
				}
			}
			copy_buffer = (_tmp25_ = g_new0 (guint8, 64 * 1024), copy_buffer_length1 = 64 * 1024, copy_buffer_size = copy_buffer_length1, _tmp25_);
			{
				gboolean _tmp26_;
#line 751 "Exif.vala"
				_tmp26_ = TRUE;
#line 751 "Exif.vala"
				while (TRUE) {
#line 2458 "Exif.c"
					gssize bytes_read;
#line 751 "Exif.vala"
					if (!_tmp26_) {
#line 2462 "Exif.c"
					}
#line 751 "Exif.vala"
					_tmp26_ = FALSE;
#line 752 "Exif.vala"
					bytes_read = g_input_stream_read (G_INPUT_STREAM (fins), copy_buffer, (gsize) copy_buffer_length1, NULL, &_inner_error_);
#line 2468 "Exif.c"
					if (_inner_error_ != NULL) {
						_g_object_unref0 (temp);
						_g_object_unref0 (fouts);
						copy_buffer = (g_free (copy_buffer), NULL);
						goto __finally27;
					}
#line 753 "Exif.vala"
					if (bytes_read == 0) {
#line 754 "Exif.vala"
						break;
#line 2479 "Exif.c"
					}
#line 756 "Exif.vala"
					g_assert (bytes_read > 0);
#line 758 "Exif.vala"
					g_output_stream_write_all (G_OUTPUT_STREAM (fouts), copy_buffer, (gsize) bytes_read, &bytes_written, NULL, &_inner_error_);
#line 2485 "Exif.c"
					if (_inner_error_ != NULL) {
						_g_object_unref0 (temp);
						_g_object_unref0 (fouts);
						copy_buffer = (g_free (copy_buffer), NULL);
						goto __finally27;
					}
#line 759 "Exif.vala"
					g_assert (bytes_written == bytes_read);
#line 2494 "Exif.c"
				}
			}
#line 763 "Exif.vala"
			g_output_stream_close (G_OUTPUT_STREAM (fouts), NULL, &_inner_error_);
#line 2499 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				copy_buffer = (g_free (copy_buffer), NULL);
				goto __finally27;
			}
#line 764 "Exif.vala"
			g_input_stream_close (G_INPUT_STREAM (fins), NULL, &_inner_error_);
#line 2508 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				copy_buffer = (g_free (copy_buffer), NULL);
				goto __finally27;
			}
#line 766 "Exif.vala"
			g_file_move (temp, self->priv->file, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 2517 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				copy_buffer = (g_free (copy_buffer), NULL);
				goto __finally27;
			}
			_g_object_unref0 (temp);
			_g_object_unref0 (fouts);
			copy_buffer = (g_free (copy_buffer), NULL);
		}
	}
	__finally27:
	{
#line 769 "Exif.vala"
		free (flattened);
#line 2533 "Exif.c"
	}
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return;
	}
	_g_object_unref0 (fins);
}


#line 773 "Exif.vala"
static GFileOutputStream* photo_exif_create_temp (GFile* original, GFile** temp, GError** error) {
#line 2546 "Exif.c"
	GFileOutputStream* result;
	GError * _inner_error_;
	GFile* parent;
#line 773 "Exif.vala"
	g_return_val_if_fail (G_IS_FILE (original), NULL);
#line 2552 "Exif.c"
	if (temp != NULL) {
		*temp = NULL;
	}
	_inner_error_ = NULL;
#line 774 "Exif.vala"
	parent = g_file_get_parent (original);
#line 775 "Exif.vala"
	g_assert (parent != NULL);
#line 2561 "Exif.c"
	{
		gint ctr;
#line 777 "Exif.vala"
		ctr = 0;
#line 2566 "Exif.c"
		{
			gboolean _tmp0_;
#line 777 "Exif.vala"
			_tmp0_ = TRUE;
#line 777 "Exif.vala"
			while (TRUE) {
#line 2573 "Exif.c"
				char* _tmp1_;
				GFile* _tmp2_;
				GFile* t;
				GFileOutputStream* fouts;
#line 777 "Exif.vala"
				if (!_tmp0_) {
#line 777 "Exif.vala"
					ctr++;
#line 2582 "Exif.c"
				}
#line 777 "Exif.vala"
				_tmp0_ = FALSE;
#line 777 "Exif.vala"
				if (!(ctr < G_MAXINT)) {
#line 777 "Exif.vala"
					break;
#line 2590 "Exif.c"
				}
#line 778 "Exif.vala"
				t = (_tmp2_ = g_file_get_child (parent, _tmp1_ = g_strdup_printf ("shotwell.%08X.tmp", (guint) ctr)), _g_free0 (_tmp1_), _tmp2_);
#line 779 "Exif.vala"
				fouts = g_file_create (t, G_FILE_CREATE_PRIVATE, NULL, &_inner_error_);
#line 2596 "Exif.c"
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (t);
					_g_object_unref0 (parent);
					return NULL;
				}
#line 780 "Exif.vala"
				if (fouts != NULL) {
#line 2605 "Exif.c"
					GFile* _tmp3_;
#line 781 "Exif.vala"
					*temp = (_tmp3_ = _g_object_ref0 (t), _g_object_unref0 (*temp), _tmp3_);
#line 2609 "Exif.c"
					result = fouts;
					_g_object_unref0 (t);
					_g_object_unref0 (parent);
#line 783 "Exif.vala"
					return result;
#line 2615 "Exif.c"
				}
				_g_object_unref0 (t);
				_g_object_unref0 (fouts);
			}
		}
	}
	result = NULL;
	_g_object_unref0 (parent);
#line 787 "Exif.vala"
	return result;
#line 2626 "Exif.c"
}


static void value_photo_exif_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_exif_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_exif_unref (value->data[0].v_pointer);
	}
}


static void value_photo_exif_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_exif_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_exif_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_exif_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoExif* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_exif_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_exif_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoExif** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_exif_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_exif (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoExif* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_EXIF), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_exif (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_EXIF), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_exif (GValue* value, gpointer v_object) {
	PhotoExif* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_EXIF));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_EXIF));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_exif_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_exif_unref (old);
	}
}


static void photo_exif_class_init (PhotoExifClass * klass) {
	photo_exif_parent_class = g_type_class_peek_parent (klass);
	PHOTO_EXIF_CLASS (klass)->finalize = photo_exif_finalize;
	g_type_class_add_private (klass, sizeof (PhotoExifPrivate));
}


static void photo_exif_instance_init (PhotoExif * self) {
	self->priv = PHOTO_EXIF_GET_PRIVATE (self);
	self->priv->exif = NULL;
	self->priv->no_exif = FALSE;
	self->ref_count = 1;
}


static void photo_exif_finalize (PhotoExif* obj) {
	PhotoExif * self;
	self = PHOTO_EXIF (obj);
	_g_object_unref0 (self->priv->file);
	_exif_data_unref0 (self->priv->exif);
}


GType photo_exif_get_type (void) {
	static GType photo_exif_type_id = 0;
	if (photo_exif_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_exif_init, value_photo_exif_free_value, value_photo_exif_copy_value, value_photo_exif_peek_pointer, "p", value_photo_exif_collect_value, "p", value_photo_exif_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoExifClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_exif_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoExif), 0, (GInstanceInitFunc) photo_exif_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		photo_exif_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoExif", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return photo_exif_type_id;
}


gpointer photo_exif_ref (gpointer instance) {
	PhotoExif* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_exif_unref (gpointer instance) {
	PhotoExif* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_EXIF_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




