/* LibraryFiles.c generated by valac, the Vala compiler
 * generated from LibraryFiles.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <time.h>
#include <libexif/exif-data.h>
#include <stdlib.h>
#include <string.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_PHOTO_EXIF (photo_exif_get_type ())
#define PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_EXIF, PhotoExif))
#define PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_EXIF, PhotoExifClass))
#define IS_PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_EXIF))
#define IS_PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_EXIF))
#define PHOTO_EXIF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_EXIF, PhotoExifClass))

typedef struct _PhotoExif PhotoExif;
typedef struct _PhotoExifClass PhotoExifClass;
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
#define _photo_exif_unref0(var) ((var == NULL) ? NULL : (var = (photo_exif_unref (var), NULL)))



#define LIBRARY_FILES_DIRECTORY_DEPTH 3
GFile* app_dirs_get_photos_dir (void);
gboolean exif_get_timestamp (ExifData* exif, time_t* timestamp);
void disassemble_filename (const char* basename, char** name, char** ext);
GFile* library_files_generate_unique_file (const char* filename, ExifData* exif, time_t ts, gboolean* collision, GError** error);
time_t query_file_modified (GFile* file, GError** error);
PhotoExif* photo_exif_new (GFile* file);
PhotoExif* photo_exif_construct (GType object_type, GFile* file);
gpointer photo_exif_ref (gpointer instance);
void photo_exif_unref (gpointer instance);
GParamSpec* param_spec_photo_exif (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_exif (GValue* value, gpointer v_object);
gpointer value_get_photo_exif (const GValue* value);
GType photo_exif_get_type (void);
ExifData* photo_exif_get_exif (PhotoExif* self);
void library_files_on_copy_progress (gint64 current, gint64 total);
static void _library_files_on_copy_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self);
GFile* library_files_duplicate (GFile* src, GError** error);
gboolean spin_event_loop (void);



#line 2019 "glib-2.0.vapi"
static void g_time_local (time_t time, struct tm* result) {
#line 61 "LibraryFiles.c"
	struct tm _result_ = {0};
#line 2021 "glib-2.0.vapi"
	localtime_r (&time, &_result_);
#line 65 "LibraryFiles.c"
	*result = _result_;
#line 2022 "glib-2.0.vapi"
	return;
#line 69 "LibraryFiles.c"
}


#line 10 "LibraryFiles.vala"
GFile* library_files_generate_unique_file (const char* filename, ExifData* exif, time_t ts, gboolean* collision, GError** error) {
#line 75 "LibraryFiles.c"
	GFile* result;
	GError * _inner_error_;
	GFile* dir;
	time_t timestamp;
	gboolean _tmp0_ = FALSE;
	struct tm _tmp1_ = {0};
	struct tm tm;
	GFile* _tmp3_;
	char* _tmp2_;
	GFile* _tmp5_;
	char* _tmp4_;
	GFile* _tmp7_;
	char* _tmp6_;
	GFile* file;
	char* name;
	char* ext;
	char* _tmp12_;
	char* _tmp11_ = NULL;
	char* _tmp10_;
	char* _tmp9_ = NULL;
	char* _tmp8_;
#line 10 "LibraryFiles.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 99 "LibraryFiles.c"
	_inner_error_ = NULL;
#line 12 "LibraryFiles.vala"
	dir = app_dirs_get_photos_dir ();
#line 13 "LibraryFiles.vala"
	timestamp = ts;
#line 17 "LibraryFiles.vala"
	if (exif != NULL) {
#line 17 "LibraryFiles.vala"
		_tmp0_ = !exif_get_timestamp (exif, &timestamp);
#line 109 "LibraryFiles.c"
	} else {
#line 17 "LibraryFiles.vala"
		_tmp0_ = FALSE;
#line 113 "LibraryFiles.c"
	}
#line 17 "LibraryFiles.vala"
	if (_tmp0_) {
#line 19 "LibraryFiles.vala"
		if (ts == 0) {
#line 20 "LibraryFiles.vala"
			timestamp = time (NULL);
#line 121 "LibraryFiles.c"
		}
	}
#line 23 "LibraryFiles.vala"
	tm = (g_time_local (timestamp, &_tmp1_), _tmp1_);
#line 27 "LibraryFiles.vala"
	dir = (_tmp3_ = g_file_get_child (dir, _tmp2_ = g_strdup_printf ("%04u", (guint) (tm.tm_year + 1900))), _g_object_unref0 (dir), _tmp3_);
#line 128 "LibraryFiles.c"
	_g_free0 (_tmp2_);
#line 28 "LibraryFiles.vala"
	dir = (_tmp5_ = g_file_get_child (dir, _tmp4_ = g_strdup_printf ("%02u", (guint) (tm.tm_mon + 1))), _g_object_unref0 (dir), _tmp5_);
#line 132 "LibraryFiles.c"
	_g_free0 (_tmp4_);
#line 29 "LibraryFiles.vala"
	dir = (_tmp7_ = g_file_get_child (dir, _tmp6_ = g_strdup_printf ("%02u", (guint) tm.tm_mday)), _g_object_unref0 (dir), _tmp7_);
#line 136 "LibraryFiles.c"
	_g_free0 (_tmp6_);
#line 31 "LibraryFiles.vala"
	if (!g_file_query_exists (dir, NULL)) {
#line 32 "LibraryFiles.vala"
		g_file_make_directory_with_parents (dir, NULL, &_inner_error_);
#line 142 "LibraryFiles.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (dir);
			return NULL;
		}
	}
#line 35 "LibraryFiles.vala"
	file = g_file_get_child (dir, filename);
#line 36 "LibraryFiles.vala"
	if (!g_file_query_exists (file, NULL)) {
#line 37 "LibraryFiles.vala"
		*collision = FALSE;
#line 155 "LibraryFiles.c"
		result = file;
		_g_object_unref0 (dir);
#line 39 "LibraryFiles.vala"
		return result;
#line 160 "LibraryFiles.c"
	}
#line 42 "LibraryFiles.vala"
	*collision = TRUE;
#line 164 "LibraryFiles.c"
	name = NULL;
	ext = NULL;
#line 45 "LibraryFiles.vala"
	(disassemble_filename (_tmp8_ = g_file_get_basename (file), &_tmp9_, &_tmp11_), name = (_tmp10_ = _tmp9_, _g_free0 (name), _tmp10_));
#line 45 "LibraryFiles.vala"
	ext = (_tmp12_ = _tmp11_, _g_free0 (ext), _tmp12_);
#line 171 "LibraryFiles.c"
	_g_free0 (_tmp8_);
	{
		gint ctr;
#line 48 "LibraryFiles.vala"
		ctr = 1;
#line 177 "LibraryFiles.c"
		{
			gboolean _tmp13_;
#line 48 "LibraryFiles.vala"
			_tmp13_ = TRUE;
#line 48 "LibraryFiles.vala"
			while (TRUE) {
#line 184 "LibraryFiles.c"
				char* _tmp14_;
				char* new_name;
				GFile* _tmp17_;
#line 48 "LibraryFiles.vala"
				if (!_tmp13_) {
#line 48 "LibraryFiles.vala"
					ctr++;
#line 192 "LibraryFiles.c"
				}
#line 48 "LibraryFiles.vala"
				_tmp13_ = FALSE;
#line 48 "LibraryFiles.vala"
				if (!(ctr < G_MAXINT)) {
#line 48 "LibraryFiles.vala"
					break;
#line 200 "LibraryFiles.c"
				}
				_tmp14_ = NULL;
#line 49 "LibraryFiles.vala"
				if (ext != NULL) {
#line 205 "LibraryFiles.c"
					char* _tmp15_;
#line 49 "LibraryFiles.vala"
					_tmp14_ = (_tmp15_ = g_strdup_printf ("%s_%d.%s", name, ctr, ext), _g_free0 (_tmp14_), _tmp15_);
#line 209 "LibraryFiles.c"
				} else {
					char* _tmp16_;
#line 49 "LibraryFiles.vala"
					_tmp14_ = (_tmp16_ = g_strdup_printf ("%s_%d", name, ctr), _g_free0 (_tmp14_), _tmp16_);
#line 214 "LibraryFiles.c"
				}
#line 49 "LibraryFiles.vala"
				new_name = g_strdup (_tmp14_);
#line 51 "LibraryFiles.vala"
				file = (_tmp17_ = g_file_get_child (dir, new_name), _g_object_unref0 (file), _tmp17_);
#line 53 "LibraryFiles.vala"
				if (!g_file_query_exists (file, NULL)) {
#line 222 "LibraryFiles.c"
					result = file;
					_g_free0 (_tmp14_);
					_g_free0 (new_name);
					_g_object_unref0 (dir);
					_g_free0 (name);
					_g_free0 (ext);
#line 54 "LibraryFiles.vala"
					return result;
#line 231 "LibraryFiles.c"
				}
				_g_free0 (_tmp14_);
				_g_free0 (new_name);
			}
		}
	}
	result = NULL;
	_g_object_unref0 (dir);
	_g_object_unref0 (file);
	_g_free0 (name);
	_g_free0 (ext);
#line 57 "LibraryFiles.vala"
	return result;
#line 245 "LibraryFiles.c"
}


#line 82 "LibraryFiles.vala"
static void _library_files_on_copy_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self) {
#line 251 "LibraryFiles.c"
	library_files_on_copy_progress (current_num_bytes, total_num_bytes);
}


#line 60 "LibraryFiles.vala"
GFile* library_files_duplicate (GFile* src, GError** error) {
#line 258 "LibraryFiles.c"
	GFile* result;
	GError * _inner_error_;
	time_t timestamp;
	PhotoExif* exif;
	gboolean collision = FALSE;
	ExifData* _tmp3_;
	char* _tmp2_;
	GFile* _tmp4_;
	GFile* dest;
	char* _tmp6_;
	char* _tmp5_;
#line 60 "LibraryFiles.vala"
	g_return_val_if_fail (G_IS_FILE (src), NULL);
#line 272 "LibraryFiles.c"
	_inner_error_ = NULL;
#line 61 "LibraryFiles.vala"
	timestamp = (time_t) 0;
#line 276 "LibraryFiles.c"
	{
		time_t _tmp0_;
#line 63 "LibraryFiles.vala"
		_tmp0_ = query_file_modified (src, &_inner_error_);
#line 281 "LibraryFiles.c"
		if (_inner_error_ != NULL) {
			goto __catch105_g_error;
			goto __finally105;
		}
#line 63 "LibraryFiles.vala"
		timestamp = _tmp0_;
#line 288 "LibraryFiles.c"
	}
	goto __finally105;
	__catch105_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp1_;
#line 65 "LibraryFiles.vala"
			g_critical ("LibraryFiles.vala:65: Unable to access file modification for %s: %s", _tmp1_ = g_file_get_path (src), err->message);
#line 300 "LibraryFiles.c"
			_g_free0 (_tmp1_);
			_g_error_free0 (err);
		}
	}
	__finally105:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
#line 68 "LibraryFiles.vala"
	exif = photo_exif_new (src);
#line 71 "LibraryFiles.vala"
	dest = (_tmp4_ = library_files_generate_unique_file (_tmp2_ = g_file_get_basename (src), _tmp3_ = photo_exif_get_exif (exif), timestamp, &collision, &_inner_error_), _exif_data_unref0 (_tmp3_), _g_free0 (_tmp2_), _tmp4_);
#line 314 "LibraryFiles.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_exif_unref0 (exif);
		return NULL;
	}
#line 72 "LibraryFiles.vala"
	if (dest == NULL) {
#line 322 "LibraryFiles.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Unable to generate unique pathname for destination");
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_photo_exif_unref0 (exif);
			_g_object_unref0 (dest);
			return NULL;
		}
	}
#line 75 "LibraryFiles.vala"
	g_debug ("LibraryFiles.vala:75: Copying %s to %s", _tmp5_ = g_file_get_path (src), _tmp6_ = g_file_get_path (dest));
#line 333 "LibraryFiles.c"
	_g_free0 (_tmp6_);
	_g_free0 (_tmp5_);
#line 77 "LibraryFiles.vala"
	g_file_copy (src, dest, G_FILE_COPY_ALL_METADATA, NULL, _library_files_on_copy_progress_gfile_progress_callback, NULL, &_inner_error_);
#line 338 "LibraryFiles.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_exif_unref0 (exif);
		_g_object_unref0 (dest);
		return NULL;
	}
	result = dest;
	_photo_exif_unref0 (exif);
#line 79 "LibraryFiles.vala"
	return result;
#line 349 "LibraryFiles.c"
}


#line 82 "LibraryFiles.vala"
void library_files_on_copy_progress (gint64 current, gint64 total) {
#line 83 "LibraryFiles.vala"
	spin_event_loop ();
#line 357 "LibraryFiles.c"
}




