/* Workers.c generated by valac, the Vala compiler
 * generated from Workers.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* This callback is executed when an associated BackgroundJob completes.  It is called from within*/
/* the Gtk event loop, *not* the background thread's context.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _ParamSpecBackgroundJob ParamSpecBackgroundJob;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;
typedef struct _WorkersPrivate WorkersPrivate;

#define WORKERS_TYPE_DIE_JOB (workers_die_job_get_type ())
#define WORKERS_DIE_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WORKERS_TYPE_DIE_JOB, WorkersDieJob))
#define WORKERS_DIE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WORKERS_TYPE_DIE_JOB, WorkersDieJobClass))
#define WORKERS_IS_DIE_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WORKERS_TYPE_DIE_JOB))
#define WORKERS_IS_DIE_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WORKERS_TYPE_DIE_JOB))
#define WORKERS_DIE_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WORKERS_TYPE_DIE_JOB, WorkersDieJobClass))

typedef struct _WorkersDieJob WorkersDieJob;
typedef struct _WorkersDieJobClass WorkersDieJobClass;
#define _g_async_queue_unref0(var) ((var == NULL) ? NULL : (var = (g_async_queue_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _WorkersDieJobPrivate WorkersDieJobPrivate;
typedef struct _ParamSpecWorkers ParamSpecWorkers;

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _BackgroundJobPrivate {
	CompletionCallback callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	GCancellable* cancellable;
	BackgroundJob* self;
};

struct _ParamSpecBackgroundJob {
	GParamSpec parent_instance;
};

struct _Workers {
	GTypeInstance parent_instance;
	volatile int ref_count;
	WorkersPrivate * priv;
};

struct _WorkersClass {
	GTypeClass parent_class;
	void (*finalize) (Workers *self);
};

struct _WorkersPrivate {
	GAsyncQueue* queue;
	gint thread_count;
};

struct _WorkersDieJob {
	BackgroundJob parent_instance;
	WorkersDieJobPrivate * priv;
};

struct _WorkersDieJobClass {
	BackgroundJobClass parent_class;
};

struct _ParamSpecWorkers {
	GParamSpec parent_instance;
};


static gpointer background_job_parent_class = NULL;
static WorkersDieJob* workers_die_job;
static WorkersDieJob* workers_die_job = NULL;
static gpointer workers_die_job_parent_class = NULL;
static gpointer workers_parent_class = NULL;

gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_job (GValue* value, gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void);
GType background_job_job_priority_get_type (void);
#define BACKGROUND_JOB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BACKGROUND_JOB, BackgroundJobPrivate))
enum  {
	BACKGROUND_JOB_DUMMY_PROPERTY
};
gint background_job_job_priority_compare (BackgroundJobJobPriority self, BackgroundJobJobPriority other);
BackgroundJob* background_job_construct (GType object_type, CompletionCallback callback, void* callback_target, GCancellable* cancellable);
void background_job_execute (BackgroundJob* self);
static void background_job_real_execute (BackgroundJob* self);
BackgroundJobJobPriority background_job_get_priority (BackgroundJob* self);
static BackgroundJobJobPriority background_job_real_get_priority (BackgroundJob* self);
gboolean background_job_is_cancelled (BackgroundJob* self);
void background_job_cancel (BackgroundJob* self);
static gboolean background_job_on_notify_completion (BackgroundJob* self);
static gboolean _background_job_on_notify_completion_gsource_func (gpointer self);
void background_job_internal_notify_completion (BackgroundJob* self);
static void background_job_finalize (BackgroundJob* obj);
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void);
#define WORKERS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_WORKERS, WorkersPrivate))
enum  {
	WORKERS_DUMMY_PROPERTY
};
static GType workers_die_job_get_type (void);
#define WORKERS_UNLIMITED_THREADS (-1)
#define WORKERS_THREAD_PER_CPU 0
static WorkersDieJob* workers_die_job_new (void);
static WorkersDieJob* workers_die_job_construct (GType object_type);
gint number_of_processors (void);
static void* workers_thread_start (Workers* self);
static void* _workers_thread_start_gthread_func (gpointer self);
Workers* workers_new (gint max_threads, gboolean exclusive);
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive);
static gint workers_compare_jobs (void* a, void* b);
static gint _workers_compare_jobs_gcompare_data_func (void* a, void* b, gpointer self);
void workers_enqueue (Workers* self, BackgroundJob* background_job);
void workers_die (Workers* self);
static void workers_thread_work (Workers* self, BackgroundJob* job);
enum  {
	WORKERS_DIE_JOB_DUMMY_PROPERTY
};
static void workers_die_job_real_execute (BackgroundJob* base);
static void workers_finalize (Workers* obj);



#line 24 "Workers.vala"
gint background_job_job_priority_compare (BackgroundJobJobPriority self, BackgroundJobJobPriority other) {
#line 188 "Workers.c"
	gint result;
	result = ((gint) other) - ((gint) self);
#line 25 "Workers.vala"
	return result;
#line 193 "Workers.c"
}



GType background_job_job_priority_get_type (void) {
	static GType background_job_job_priority_type_id = 0;
	if (G_UNLIKELY (background_job_job_priority_type_id == 0)) {
		static const GEnumValue values[] = {{BACKGROUND_JOB_JOB_PRIORITY_HIGHEST, "BACKGROUND_JOB_JOB_PRIORITY_HIGHEST", "highest"}, {BACKGROUND_JOB_JOB_PRIORITY_HIGH, "BACKGROUND_JOB_JOB_PRIORITY_HIGH", "high"}, {BACKGROUND_JOB_JOB_PRIORITY_NORMAL, "BACKGROUND_JOB_JOB_PRIORITY_NORMAL", "normal"}, {BACKGROUND_JOB_JOB_PRIORITY_LOW, "BACKGROUND_JOB_JOB_PRIORITY_LOW", "low"}, {BACKGROUND_JOB_JOB_PRIORITY_LOWEST, "BACKGROUND_JOB_JOB_PRIORITY_LOWEST", "lowest"}, {0, NULL, NULL}};
		background_job_job_priority_type_id = g_enum_register_static ("BackgroundJobJobPriority", values);
	}
	return background_job_job_priority_type_id;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 33 "Workers.vala"
BackgroundJob* background_job_construct (GType object_type, CompletionCallback callback, void* callback_target, GCancellable* cancellable) {
#line 215 "Workers.c"
	BackgroundJob* self;
	CompletionCallback _tmp0_;
	GCancellable* _tmp1_;
#line 33 "Workers.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 221 "Workers.c"
	self = (BackgroundJob*) g_type_create_instance (object_type);
#line 34 "Workers.vala"
	self->priv->callback = (_tmp0_ = callback, ((self->priv->callback_target_destroy_notify == NULL) ? NULL : self->priv->callback_target_destroy_notify (self->priv->callback_target), self->priv->callback = NULL, self->priv->callback_target = NULL, self->priv->callback_target_destroy_notify = NULL), self->priv->callback_target = callback_target, self->priv->callback_target_destroy_notify = NULL, _tmp0_);
#line 35 "Workers.vala"
	self->priv->cancellable = (_tmp1_ = _g_object_ref0 (cancellable), _g_object_unref0 (self->priv->cancellable), _tmp1_);
#line 227 "Workers.c"
	return self;
}


#line 43 "Workers.vala"
static void background_job_real_execute (BackgroundJob* self) {
#line 234 "Workers.c"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
	g_critical ("Type `%s' does not implement abstract method `background_job_execute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 43 "Workers.vala"
void background_job_execute (BackgroundJob* self) {
#line 43 "Workers.vala"
	BACKGROUND_JOB_GET_CLASS (self)->execute (self);
#line 245 "Workers.c"
}


#line 45 "Workers.vala"
static BackgroundJobJobPriority background_job_real_get_priority (BackgroundJob* self) {
#line 251 "Workers.c"
	BackgroundJobJobPriority result;
#line 45 "Workers.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), 0);
#line 255 "Workers.c"
	result = BACKGROUND_JOB_JOB_PRIORITY_NORMAL;
#line 46 "Workers.vala"
	return result;
#line 259 "Workers.c"
}


#line 45 "Workers.vala"
BackgroundJobJobPriority background_job_get_priority (BackgroundJob* self) {
#line 45 "Workers.vala"
	return BACKGROUND_JOB_GET_CLASS (self)->get_priority (self);
#line 267 "Workers.c"
}


#line 49 "Workers.vala"
gboolean background_job_is_cancelled (BackgroundJob* self) {
#line 273 "Workers.c"
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 49 "Workers.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), FALSE);
#line 50 "Workers.vala"
	if (self->priv->cancellable != NULL) {
#line 50 "Workers.vala"
		_tmp0_ = g_cancellable_is_cancelled (self->priv->cancellable);
#line 282 "Workers.c"
	} else {
#line 50 "Workers.vala"
		_tmp0_ = FALSE;
#line 286 "Workers.c"
	}
	result = _tmp0_;
#line 50 "Workers.vala"
	return result;
#line 291 "Workers.c"
}


#line 53 "Workers.vala"
void background_job_cancel (BackgroundJob* self) {
#line 53 "Workers.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 54 "Workers.vala"
	if (self->priv->cancellable != NULL) {
#line 55 "Workers.vala"
		g_cancellable_cancel (self->priv->cancellable);
#line 303 "Workers.c"
	}
}


static gpointer _background_job_ref0 (gpointer self) {
	return self ? background_job_ref (self) : NULL;
}


#line 70 "Workers.vala"
static gboolean _background_job_on_notify_completion_gsource_func (gpointer self) {
#line 315 "Workers.c"
	return background_job_on_notify_completion (self);
}


#line 59 "Workers.vala"
void background_job_internal_notify_completion (BackgroundJob* self) {
#line 322 "Workers.c"
	BackgroundJob* _tmp0_;
#line 59 "Workers.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (self));
#line 60 "Workers.vala"
	if (self->priv->callback == NULL) {
#line 61 "Workers.vala"
		return;
#line 330 "Workers.c"
	}
#line 65 "Workers.vala"
	self->priv->self = (_tmp0_ = _background_job_ref0 (self), _background_job_unref0 (self->priv->self), _tmp0_);
#line 67 "Workers.vala"
	g_idle_add_full (G_PRIORITY_HIGH, _background_job_on_notify_completion_gsource_func, background_job_ref (self), background_job_unref);
#line 336 "Workers.c"
}


#line 70 "Workers.vala"
static gboolean background_job_on_notify_completion (BackgroundJob* self) {
#line 342 "Workers.c"
	gboolean result;
	BackgroundJob* _tmp0_;
#line 70 "Workers.vala"
	g_return_val_if_fail (IS_BACKGROUND_JOB (self), FALSE);
#line 75 "Workers.vala"
	if (!background_job_is_cancelled (self)) {
#line 76 "Workers.vala"
		self->priv->callback (self, self->priv->callback_target);
#line 351 "Workers.c"
	}
#line 79 "Workers.vala"
	self->priv->self = (_tmp0_ = NULL, _background_job_unref0 (self->priv->self), _tmp0_);
#line 355 "Workers.c"
	result = FALSE;
#line 81 "Workers.vala"
	return result;
#line 359 "Workers.c"
}


static void value_background_job_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_background_job_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		background_job_unref (value->data[0].v_pointer);
	}
}


static void value_background_job_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = background_job_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_background_job_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_background_job_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		BackgroundJob* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = background_job_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_background_job_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	BackgroundJob** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = background_job_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecBackgroundJob* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BACKGROUND_JOB), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_background_job (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB), NULL);
	return value->data[0].v_pointer;
}


void value_set_background_job (GValue* value, gpointer v_object) {
	BackgroundJob* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BACKGROUND_JOB));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BACKGROUND_JOB));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		background_job_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		background_job_unref (old);
	}
}


static void background_job_class_init (BackgroundJobClass * klass) {
	background_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = background_job_finalize;
	g_type_class_add_private (klass, sizeof (BackgroundJobPrivate));
	BACKGROUND_JOB_CLASS (klass)->execute = background_job_real_execute;
	BACKGROUND_JOB_CLASS (klass)->get_priority = background_job_real_get_priority;
}


static void background_job_instance_init (BackgroundJob * self) {
	self->priv = BACKGROUND_JOB_GET_PRIVATE (self);
	self->priv->self = NULL;
	self->ref_count = 1;
}


static void background_job_finalize (BackgroundJob* obj) {
	BackgroundJob * self;
	self = BACKGROUND_JOB (obj);
	{
#line 39 "Workers.vala"
		if (self->priv->cancellable != NULL) {
#line 40 "Workers.vala"
			g_cancellable_cancel (self->priv->cancellable);
#line 480 "Workers.c"
		}
	}
	(self->priv->callback_target_destroy_notify == NULL) ? NULL : self->priv->callback_target_destroy_notify (self->priv->callback_target);
	self->priv->callback = NULL;
	self->priv->callback_target = NULL;
	self->priv->callback_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->cancellable);
	_background_job_unref0 (self->priv->self);
}


GType background_job_get_type (void) {
	static GType background_job_type_id = 0;
	if (background_job_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { value_background_job_init, value_background_job_free_value, value_background_job_copy_value, value_background_job_peek_pointer, "p", value_background_job_collect_value, "p", value_background_job_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BackgroundJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundJob), 0, (GInstanceInitFunc) background_job_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		background_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BackgroundJob", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	}
	return background_job_type_id;
}


gpointer background_job_ref (gpointer instance) {
	BackgroundJob* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void background_job_unref (gpointer instance) {
	BackgroundJob* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		BACKGROUND_JOB_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 147 "Workers.vala"
static void* _workers_thread_start_gthread_func (gpointer self) {
#line 524 "Workers.c"
	return workers_thread_start (self);
}


#line 106 "Workers.vala"
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive) {
#line 531 "Workers.c"
	GError * _inner_error_;
	Workers* self;
	GAsyncQueue* _tmp1_;
	_inner_error_ = NULL;
	self = (Workers*) g_type_create_instance (object_type);
#line 107 "Workers.vala"
	if (workers_die_job == NULL) {
#line 539 "Workers.c"
		WorkersDieJob* _tmp0_;
#line 108 "Workers.vala"
		workers_die_job = (_tmp0_ = workers_die_job_new (), _background_job_unref0 (workers_die_job), _tmp0_);
#line 543 "Workers.c"
	}
#line 110 "Workers.vala"
	if (max_threads == WORKERS_UNLIMITED_THREADS) {
#line 111 "Workers.vala"
		max_threads = WORKERS_THREAD_PER_CPU;
#line 549 "Workers.c"
	}
#line 113 "Workers.vala"
	if (max_threads == WORKERS_THREAD_PER_CPU) {
#line 114 "Workers.vala"
		max_threads = number_of_processors ();
#line 555 "Workers.c"
	}
#line 116 "Workers.vala"
	self->priv->queue = (_tmp1_ = g_async_queue_new (), _g_async_queue_unref0 (self->priv->queue), _tmp1_);
#line 117 "Workers.vala"
	self->priv->thread_count = max_threads;
#line 119 "Workers.vala"
	g_assert (self->priv->thread_count > 0);
#line 563 "Workers.c"
	{
		gint ctr;
#line 120 "Workers.vala"
		ctr = 0;
#line 568 "Workers.c"
		{
			gboolean _tmp2_;
#line 120 "Workers.vala"
			_tmp2_ = TRUE;
#line 120 "Workers.vala"
			while (TRUE) {
#line 120 "Workers.vala"
				if (!_tmp2_) {
#line 120 "Workers.vala"
					ctr++;
#line 579 "Workers.c"
				}
#line 120 "Workers.vala"
				_tmp2_ = FALSE;
#line 120 "Workers.vala"
				if (!(ctr < self->priv->thread_count)) {
#line 120 "Workers.vala"
					break;
#line 587 "Workers.c"
				}
				{
#line 122 "Workers.vala"
					g_thread_create (_workers_thread_start_gthread_func, self, FALSE, &_inner_error_);
#line 592 "Workers.c"
					if (_inner_error_ != NULL) {
						goto __catch80_g_error;
						goto __finally80;
					}
				}
				goto __finally80;
				__catch80_g_error:
				{
					GError * err;
					err = _inner_error_;
					_inner_error_ = NULL;
					{
#line 124 "Workers.vala"
						g_error ("Workers.vala:124: Unable to create worker thread: %s", err->message);
#line 607 "Workers.c"
						_g_error_free0 (err);
					}
				}
				__finally80:
				if (_inner_error_ != NULL) {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
	}
	return self;
}


#line 106 "Workers.vala"
Workers* workers_new (gint max_threads, gboolean exclusive) {
#line 106 "Workers.vala"
	return workers_construct (TYPE_WORKERS, max_threads, exclusive);
#line 628 "Workers.c"
}


#line 135 "Workers.vala"
static gint _workers_compare_jobs_gcompare_data_func (void* a, void* b, gpointer self) {
#line 634 "Workers.c"
	return workers_compare_jobs (a, b);
}


#line 131 "Workers.vala"
void workers_enqueue (Workers* self, BackgroundJob* background_job) {
#line 131 "Workers.vala"
	g_return_if_fail (IS_WORKERS (self));
#line 131 "Workers.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (background_job));
#line 132 "Workers.vala"
	g_async_queue_push_sorted (self->priv->queue, _background_job_ref0 (background_job), _workers_compare_jobs_gcompare_data_func, NULL);
#line 647 "Workers.c"
}


#line 135 "Workers.vala"
static gint workers_compare_jobs (void* a, void* b) {
#line 653 "Workers.c"
	gint result;
	BackgroundJobJobPriority a_priority;
	BackgroundJobJobPriority b_priority;
#line 136 "Workers.vala"
	a_priority = background_job_get_priority (BACKGROUND_JOB ((BackgroundJob*) a));
#line 137 "Workers.vala"
	b_priority = background_job_get_priority (BACKGROUND_JOB ((BackgroundJob*) b));
#line 661 "Workers.c"
	result = background_job_job_priority_compare (a_priority, b_priority);
#line 139 "Workers.vala"
	return result;
#line 665 "Workers.c"
}


#line 142 "Workers.vala"
void workers_die (Workers* self) {
#line 142 "Workers.vala"
	g_return_if_fail (IS_WORKERS (self));
#line 673 "Workers.c"
	{
		gint ctr;
#line 143 "Workers.vala"
		ctr = 0;
#line 678 "Workers.c"
		{
			gboolean _tmp0_;
#line 143 "Workers.vala"
			_tmp0_ = TRUE;
#line 143 "Workers.vala"
			while (TRUE) {
#line 143 "Workers.vala"
				if (!_tmp0_) {
#line 143 "Workers.vala"
					ctr++;
#line 689 "Workers.c"
				}
#line 143 "Workers.vala"
				_tmp0_ = FALSE;
#line 143 "Workers.vala"
				if (!(ctr < self->priv->thread_count)) {
#line 143 "Workers.vala"
					break;
#line 697 "Workers.c"
				}
#line 144 "Workers.vala"
				workers_enqueue (self, BACKGROUND_JOB (workers_die_job));
#line 701 "Workers.c"
			}
		}
	}
}


#line 147 "Workers.vala"
static void* workers_thread_start (Workers* self) {
#line 710 "Workers.c"
	void* result;
#line 147 "Workers.vala"
	g_return_val_if_fail (IS_WORKERS (self), NULL);
#line 714 "Workers.c"
	{
		gboolean _tmp0_;
#line 148 "Workers.vala"
		_tmp0_ = TRUE;
#line 148 "Workers.vala"
		while (TRUE) {
#line 721 "Workers.c"
			BackgroundJob* job;
			gboolean _tmp1_ = FALSE;
#line 148 "Workers.vala"
			if (!_tmp0_) {
#line 726 "Workers.c"
			}
#line 148 "Workers.vala"
			_tmp0_ = FALSE;
#line 149 "Workers.vala"
			job = (BackgroundJob*) g_async_queue_pop (self->priv->queue);
#line 150 "Workers.vala"
			if (job == NULL) {
#line 150 "Workers.vala"
				_tmp1_ = TRUE;
#line 736 "Workers.c"
			} else {
#line 150 "Workers.vala"
				_tmp1_ = job == BACKGROUND_JOB (workers_die_job);
#line 740 "Workers.c"
			}
#line 150 "Workers.vala"
			if (_tmp1_) {
#line 744 "Workers.c"
				_background_job_unref0 (job);
#line 151 "Workers.vala"
				break;
#line 748 "Workers.c"
			}
#line 153 "Workers.vala"
			workers_thread_work (self, job);
#line 752 "Workers.c"
			_background_job_unref0 (job);
		}
	}
	result = NULL;
#line 156 "Workers.vala"
	return result;
#line 759 "Workers.c"
}


#line 159 "Workers.vala"
static void workers_thread_work (Workers* self, BackgroundJob* job) {
#line 159 "Workers.vala"
	g_return_if_fail (IS_WORKERS (self));
#line 159 "Workers.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (job));
#line 160 "Workers.vala"
	if (background_job_is_cancelled (job)) {
#line 161 "Workers.vala"
		return;
#line 773 "Workers.c"
	}
#line 163 "Workers.vala"
	background_job_execute (job);
#line 165 "Workers.vala"
	background_job_internal_notify_completion (job);
#line 779 "Workers.c"
}


#line 97 "Workers.vala"
static void workers_die_job_real_execute (BackgroundJob* base) {
#line 785 "Workers.c"
	WorkersDieJob * self;
	self = WORKERS_DIE_JOB (base);
}


#line 96 "Workers.vala"
static WorkersDieJob* workers_die_job_construct (GType object_type) {
#line 793 "Workers.c"
	WorkersDieJob* self;
#line 96 "Workers.vala"
	self = (WorkersDieJob*) background_job_construct (object_type, NULL, NULL, NULL);
#line 797 "Workers.c"
	return self;
}


#line 96 "Workers.vala"
static WorkersDieJob* workers_die_job_new (void) {
#line 96 "Workers.vala"
	return workers_die_job_construct (WORKERS_TYPE_DIE_JOB);
#line 806 "Workers.c"
}


static void workers_die_job_class_init (WorkersDieJobClass * klass) {
	workers_die_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->execute = workers_die_job_real_execute;
}


static void workers_die_job_instance_init (WorkersDieJob * self) {
}


static GType workers_die_job_get_type (void) {
	static GType workers_die_job_type_id = 0;
	if (workers_die_job_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (WorkersDieJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) workers_die_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WorkersDieJob), 0, (GInstanceInitFunc) workers_die_job_instance_init, NULL };
		workers_die_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "WorkersDieJob", &g_define_type_info, 0);
	}
	return workers_die_job_type_id;
}


static void value_workers_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_workers_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		workers_unref (value->data[0].v_pointer);
	}
}


static void value_workers_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = workers_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_workers_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_workers_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Workers* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = workers_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_workers_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Workers** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = workers_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecWorkers* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_WORKERS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_workers (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_WORKERS), NULL);
	return value->data[0].v_pointer;
}


void value_set_workers (GValue* value, gpointer v_object) {
	Workers* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_WORKERS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_WORKERS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		workers_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		workers_unref (old);
	}
}


static void workers_class_init (WorkersClass * klass) {
	workers_parent_class = g_type_class_peek_parent (klass);
	WORKERS_CLASS (klass)->finalize = workers_finalize;
	g_type_class_add_private (klass, sizeof (WorkersPrivate));
}


static void workers_instance_init (Workers * self) {
	self->priv = WORKERS_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void workers_finalize (Workers* obj) {
	Workers * self;
	self = WORKERS (obj);
	_g_async_queue_unref0 (self->priv->queue);
}


GType workers_get_type (void) {
	static GType workers_type_id = 0;
	if (workers_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { value_workers_init, value_workers_free_value, value_workers_copy_value, value_workers_peek_pointer, "p", value_workers_collect_value, "p", value_workers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (WorkersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) workers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Workers), 0, (GInstanceInitFunc) workers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		workers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Workers", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return workers_type_id;
}


gpointer workers_ref (gpointer instance) {
	Workers* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void workers_unref (gpointer instance) {
	Workers* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		WORKERS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




